############################################################
#     (c)2007-2011 Broadcom Corporation
#
#  This program is the proprietary software of Broadcom Corporation and/or its licensors,
#  and may only be used, duplicated, modified or distributed pursuant to the terms and
#  conditions of a separate, written license agreement executed between you and Broadcom
#  (an "Authorized License").  Except as set forth in an Authorized License, Broadcom grants
#  no license (express or implied), right to use, or waiver of any kind with respect to the
#  Software, and Broadcom expressly reserves all rights in and to the Software and all
#  intellectual property rights therein.  IF YOU HAVE NO AUTHORIZED LICENSE, THEN YOU
#  HAVE NO RIGHT TO USE THIS SOFTWARE IN ANY WAY, AND SHOULD IMMEDIATELY
#  NOTIFY BROADCOM AND DISCONTINUE ALL USE OF THE SOFTWARE.
#
#  Except as expressly set forth in the Authorized License,
#
#  1.     This program, including its structure, sequence and organization, constitutes the valuable trade
#  secrets of Broadcom, and you shall use all reasonable efforts to protect the confidentiality thereof,
#  and to use this information only in connection with your use of Broadcom integrated circuit products.
#
#  2.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, THE SOFTWARE IS PROVIDED "AS IS"
#  AND WITH ALL FAULTS AND BROADCOM MAKES NO PROMISES, REPRESENTATIONS OR
#  WARRANTIES, EITHER EXPRESS, IMPLIED, STATUTORY, OR OTHERWISE, WITH RESPECT TO
#  THE SOFTWARE.  BROADCOM SPECIFICALLY DISCLAIMS ANY AND ALL IMPLIED WARRANTIES
#  OF TITLE, MERCHANTABILITY, NONINFRINGEMENT, FITNESS FOR A PARTICULAR PURPOSE,
#  LACK OF VIRUSES, ACCURACY OR COMPLETENESS, QUIET ENJOYMENT, QUIET POSSESSION
#  OR CORRESPONDENCE TO DESCRIPTION. YOU ASSUME THE ENTIRE RISK ARISING OUT OF
#  USE OR PERFORMANCE OF THE SOFTWARE.
#
#  3.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, IN NO EVENT SHALL BROADCOM OR ITS
#  LICENSORS BE LIABLE FOR (i) CONSEQUENTIAL, INCIDENTAL, SPECIAL, INDIRECT, OR
#  EXEMPLARY DAMAGES WHATSOEVER ARISING OUT OF OR IN ANY WAY RELATING TO YOUR
#  USE OF OR INABILITY TO USE THE SOFTWARE EVEN IF BROADCOM HAS BEEN ADVISED OF
#  THE POSSIBILITY OF SUCH DAMAGES; OR (ii) ANY AMOUNT IN EXCESS OF THE AMOUNT
#  ACTUALLY PAID FOR THE SOFTWARE ITSELF OR U.S. $1, WHICHEVER IS GREATER. THESE
#  LIMITATIONS SHALL APPLY NOTWITHSTANDING ANY FAILURE OF ESSENTIAL PURPOSE OF
#  ANY LIMITED REMEDY.
#
# $brcm_Workfile: directfb_common.inc $
# $brcm_Revision: DirectFB_1_4_Port/DirectFB_1_4_5/15 $
# $brcm_Date: 3/21/11 7:26p $
#
# Module Description:
#
# Revision History:
#
# Created: 1st December 2009 by Rob McConnell
#
# $brcm_Log: /AppLibs/opensource/directfb/build/1.4.5/directfb_common.inc $
# 
# DirectFB_1_4_Port/DirectFB_1_4_5/15   3/21/11 7:26p robertwm
# SW7420-1714: DirectFB-1.4.5: Make a DirectFB-1.4.1 Phase 1.5 Release.
# 
# DirectFB_1_4_Port/DirectFB_1_4_5/14   3/21/11 5:27p robertwm
# SW7422-393: DirectFB: Hang in graphics driver due to serialisation of
#  graphics packet-buffer.
# 
# DirectFB_1_4_Port/DirectFB_1_4_5/13   3/20/11 11:00a robertwm
# SW7420-1705: DirectFB: Default to non-packet buffer mode due to lockup
#  with WebKit in single-app mode.
# 
# DirectFB_1_4_Port/DirectFB_1_4_5/12   3/17/11 9:46p robertwm
# SW7422-390: DirectFB-1.4.5: Need to make a DirectFB-1.4.5 Phase 1.5
#  Official release.
# 
# DirectFB_1_4_Port/DirectFB_1_4_5/11   3/14/11 5:55p robertwm
# SW3556-1224: DirectFB: Cannot build IR driver for 3556 platform.
# SW3556-1225: DirectFB: DirectFB-1.4.1 Phase 3.0 PreRel fails to build.
# SW35125-128: DirectFB: IR remote protocol default is wrong and causes
#  compilation error.
# SW7420-1654: DirectFB: Add run-time IR protocol and keymap selection.
# 
# DirectFB_1_4_Port/DirectFB_1_4_5/10   3/4/11 9:54p robertwm
# SW7405-5176: DirectFB: Cannot build DFB when
#  broadcom_files/private/DirectFB/1.4 is empty.
# 
# DirectFB_1_4_Port/DirectFB_1_4_5/9   3/4/11 7:34p robertwm
# SW7420-1594: DirectFB: Create an engineering release of DirectFB-1.4.1
#  Phase 3.0 and DirectFB-1.4.5 Phase 1.5.
# 
# DirectFB_1_4_Port/DirectFB_1_4_5/8   3/1/11 9:08p robertwm
# SW7422-265: DirectFB: Remove circular dependency when building OGL2.0
#  V3D applications.
# 
# DirectFB_1_4_Port/DirectFB_1_4_5/7   2/15/11 2:40p robertwm
# SW7422-254: DirectFB: Cannot build DFB for VC-4 platforms.
# 
# DirectFB_1_4_Port/DirectFB_1_4_5/6   1/31/11 6:45p robertwm
# SW7420-1450: DirectFB-1.4.5: Change Insignia and Tacho test versions to
#  0.1.2.
# 
# DirectFB_1_4_Port/DirectFB_1_4_5/5   1/31/11 5:32p robertwm
# SW7420-1447: Require ++DFB-1.4.2 rather than ++DFB-1.4.5
# 
# DirectFB_1_4_Port/DirectFB_1_4_5/4   10/28/10 2:28p robertwm
# SW7405-4967: DirectFB: Add support for DIRECTFB_VERSION_VENDOR.
# SW35230-611: DirectFB: Changes to incorporate building nexus shim into
#  Makefile.
# 
# DirectFB_1_4_Port/DirectFB_1_4_5/3   10/21/10 8:27a robertwm
# SW7405-4906: DirectFB: Need to make a DirectFB-1.4.5 Release.
# 
# DirectFB_1_4_Port/DirectFB_1_4_5/2   10/21/10 3:23a robertwm
# SW7405-4960: DirectFB-1.4.5: Add support for ++DFB-1.4.5.
# 
# DirectFB_1_4_Port/DirectFB_1_4_5/1   10/21/10 2:06a robertwm
# SW7420-1182: DirectFB-1.4.5: Enable per-version build options and
#  defines.
# 
# DirectFB_1_4_Port/67   3/14/11 4:08p robertwm
# SW3556-1224: DirectFB: Cannot build IR driver for 3556 platform.
# SW3556-1225: DirectFB: DirectFB-1.4.1 Phase 3.0 PreRel fails to build.
# SW35125-128: DirectFB: IR remote protocol default is wrong and causes
#  compilation error.
# SW7420-1654: DirectFB: Add run-time IR protocol and keymap selection.
# 
# DirectFB_1_4_Port/66   3/9/11 12:11p apandav
# SW35125-124: DirectFB Build fails on BCM35125
# 
# DirectFB_1_4_Port/65   3/9/11 11:08a apandav
# SW35125-124: DirectFB Build fails on BCM35125 -- Reverting changes
# 
# DirectFB_1_4_Port/64   3/8/11 6:27p apandav
# SW35125-124: DirectFB Build fails on BCM35125
# 
# DirectFB_1_4_Port/63   3/4/11 9:55p robertwm
# SW7405-5176: DirectFB: Cannot build DFB when
#  broadcom_files/private/DirectFB/1.4 is empty.
# 
# DirectFB_1_4_Port/62   3/4/11 7:36p robertwm
# SW7420-1594: DirectFB: Create an engineering release of DirectFB-1.4.1
#  Phase 3.0 and DirectFB-1.4.5 Phase 1.5.
# 
# DirectFB_1_4_Port/61   2/16/11 11:44a robertwm
# SW7422-265: DirectFB: Remove circular dependency when building OGL2.0
#  V3D applications.
# 
# DirectFB_1_4_Port/60   2/16/11 11:39a robertwm
# SW7422-265: DirectFB: Remove circular dependency when building OGL2.0
#  V3D applications.
# 
# DirectFB_1_4_Port/59   2/15/11 5:22p apandav
# SW35230-3031: Restoring changes
# 
# DirectFB_1_4_Port/58   2/15/11 2:36p robertwm
# SW7422-254: DirectFB: Cannot build DFB for VC-4 platforms.
# 
# DirectFB_1_4_Port/57   2/15/11 1:16p apandav
# SW35230-3031: DirectFB: Build fails with error 'make[1]: execvp:
#  /bin/sh: Argument list too long'
# 
# DirectFB_1_4_Port/56   1/25/11 2:58p christ
#  SW7420-1411: DirectFB: Merge of features required for DirectFB 1.4.5
#  phase 1.5 release - Always enable packet blit gfx driver mode.
# 
# DirectFB_1_4_Port/55   12/14/10 2:42p robertwm
# SW7422-140: DirectFB: Support OpenGL ES 2.0 applications on the VC-4
#  core.
# 
# DirectFB_1_4_Port/54   12/14/10 1:20p scchang
# SW7420-1313: Add bluetooth handset support
# 
# DirectFB_1_4_Port/53   12/3/10 8:36p raywu
# SW7550-629: DirectFB: Integrated ZSP code to DFB packet buffer branch
# 
# DirectFB_1_4_Port/52   11/17/10 4:48p robertwm
# SW7420-1242: DirectFB: Add support for SetMatrix() function for both
#  M2MC and PX3D cores.
# 
# DirectFB_1_4_Port/51   11/15/10 2:48p robertwm
# SW7420-1241: DirectFB: Add support for FillTrapezoid() to the driver
#  and core.
# 
# DirectFB_1_4_Port/50   10/28/10 1:46p robertwm
# SW7405-4967: DirectFB: Add support for DIRECTFB_VERSION_VENDOR.
# 
# DirectFB_1_4_Port/49   10/28/10 11:27a robertwm
# SW35230-611: DirectFB: Changes to incorporate building nexus shim into
#  Makefile.
# 
# DirectFB_1_4_Port/48   10/25/10 12:15p robertwm
# SW7405-4967: DirectFB: Add support for DIRECTFB_VERSION_VENDOR.
# 
# DirectFB_1_4_Port/47   10/21/10 8:32a robertwm
# SW7405-4906: DirectFB: Need to make a DirectFB-1.4.5 Release.
# 
# DirectFB_1_4_Port/46   10/21/10 2:09a robertwm
# SW7420-1182: DirectFB-1.4.5: Enable per-version build options and
#  defines.
# 
# DirectFB_1_4_Port/45   10/21/10 2:01a robertwm
# SW7420-1182: DirectFB-1.4.5: Enable per-version build options and
#  defines.
# 
# DirectFB_1_4_Port/44   10/21/10 1:08a robertwm
# SW7420-1182: DirectFB-1.4.5: Enable per-version build options and
#  defines.
# 
# DirectFB_1_4_Port/43   10/20/10 5:40p robertwm
# SW7420-1182: DirectFB-1.4.5: Enable per-version build options and
#  defines.
# 
# DirectFB_1_4_Port/42   10/15/10 7:47p robertwm
# SW7420-1182: DirectFB-1.4.5: Enable per-version build options and
#  defines.
# 
# DirectFB_1_4_Port/41   10/13/10 4:01p robertwm
# SW7420-1166: DirectFB: Add dither software support for ARGB4444 pixel
#  formats.
# 
# DirectFB_1_4_Port/40   10/8/10 11:13a raywu
# SW7420-1134: Add packet buffer (blit) support for gfxdriver
# 
# DirectFB_1_4_Port/39   9/23/10 9:47a robertwm
# SW7420-1112: DirectFB: Cannot build DirectFB with LATEST refsw due to
#  corrupt bcmnexus_gfx_defines.h.
# 
# DirectFB_1_4_Port/38   8/25/10 1:06p robertwm
# SW7405-4812: DirectFB: Missing "docs" folder when creating a "release".
# 
# DirectFB_1_4_Port/37   8/20/10 8:55p robertwm
# SW7405-4793: DirectFB: Add support for Insignia and Tacho Tests.
# 
# DirectFB_1_4_Port/36   8/19/10 4:32p robertwm
# SW35230-1060: DirectFB: Add support for building DFB with different IR
#  keycode tables.
# 
# DirectFB_1_4_Port/35   8/17/10 3:57a robertwm
# SW7405-4765: DirectFB: Create a DirectFB-1.4.1 Phase 2.5 Release.
# 
# DirectFB_1_4_Port/34   8/11/10 8:22p robertwm
# SW7405-4745: DirectFB: Add "mrproper" option to delete all files
#  without prompting the user.
# 
# DirectFB_1_4_Port/33   8/11/10 4:55p robertwm
# SW35230-967: DirectFB: Cannot build IR module for 35230.
# SW35230-957: DirectFB: platform_init fails to build on 35230 with
#  recent 3D changes.
# 
# DirectFB_1_4_Port/32   8/9/10 9:20p robertwm
# SW7405-4183: DirectFB: Add support for Texture Triangles in the
#  graphics driver.
# SW7405-4734: DirectFB: Add hardware support for FillTriangle().
# 
# DirectFB_1_4_Port/31   8/6/10 8:38p robertwm
# SW7405-4724: DirectFB: Support OpenGL ES 1.0 applications.
# 
# DirectFB_1_4_Port/30   6/30/10 1:12p robertwm
# SW7405-4562: DirectFB: Add support for building DiVine.
# SW7405-4572: DirectFB: Add support for building Voodoo.
# 
# DirectFB_1_4_Port/29   6/18/10 7:27a robertwm
# SW7420-741: Change the toolchain to mipsel-linux-uclinux.
# 
# DirectFB_1_4_Port/28   6/11/10 10:57a ismailk
# SW7420-741: Roll back the new toolchain changes temporarily.
# 
# DirectFB_1_4_Port/27   5/27/10 6:52p ismailk
# SW7420-741: Change the toolchain to mipsel-linux-uclinux.
#
# DirectFB_1_4_Port/26   5/26/10 2:45p robertwm
# SW7420-776: DirectFB: Provide build options to enable/disable the
#  DirectFB unittests (in tests dir).
#
# DirectFB_1_4_Port/25   4/30/10 11:06a robertwm
# SW7400-2755: DirectFB: Parsing of Linux version fails on customer
#  specific kernels.
#
# DirectFB_1_4_Port/24   4/20/10 12:59p robertwm
# SW7405-4215: DirectFB: Create a DirectFB-1.4.1 Phase 2.0 Release.
#
# DirectFB_1_4_Port/23   4/19/10 2:44p robertwm
# SW3556-1097: DirectFB: videoAndGfxLayersTest.c fails to build for DTV
#  platforms.
#
# DirectFB_1_4_Port/22   4/15/10 3:47p robertwm
# SW7405-4211: DirectFB: Add support for enabling software dithering and
#  smooth scaling.
#
# DirectFB_1_4_Port/21   4/12/10 11:59a robertwm
# SW7405-4182: DirectFB: Print the DirectFB Phase or source code date in
#  the banner.
#
# DirectFB_1_4_Port/20   4/9/10 4:11p robertwm
# SW7405-4181: DirectFB: Allow the graphics and system module versions to
#  be specified in the build system.
#
# DirectFB_1_4_Port/19   3/25/10 3:58p robertwm
# SW7400-2725: DirectFB: Re-factor build system to separate SLA and LGPL
#  code.
#
# DirectFB_1_4_Port/18   3/17/10 6:42p robertwm
# SW7405-4031: DirectFB: Move linux-fusion to
#  AppLibs/opensource/directfb.
# SW7420-608: Restructure Applibs Directory Structure.
#
# DirectFB_1_4_Port/17   3/12/10 7:12p robertwm
# SW7420-608: Restructure Applibs Directory Structure (move DFB bins to
#  /usr/local/bin/directfb/1.4).
#
# DirectFB_1_4_Port/16   3/10/10 1:33p robertwm
# SW7420-608: Restructure Applibs Directory Structure (moved output to
#  target dir).
#
# DirectFB_1_4_Port/15   3/4/10 7:53p robertwm
# SW7420-608: Restructure Applibs Directory Structure (added uninstall
#  targets).
#
# DirectFB_1_4_Port/14   3/3/10 3:10p robertwm
# SW7420-608: Restructure Applibs Directory Structure (move DirectFB to
#  AppLibs/opensource).
#
# DirectFB_1_4_Port/13   3/3/10 1:35p robertwm
# SW7468-132: DirectFB: Failure to configure png.
#
# DirectFB_1_4_Port/12   3/2/10 12:53p robertwm
# SW7405-3981: DirectFB: Disable devmem system module from being built.
#
# DirectFB_1_4_Port/11   2/26/10 11:15a robertwm
# SW7405-3971: DirectFB: Allow prefix and version variables to be
#  overriden in the shell environment.
#
# DirectFB_1_4_Port/10   2/24/10 6:44p robertwm
# SW7468-125: DirectFB: Provide ability to separately build IR and Keypad
#  input drivers.
#
# DirectFB_1_4_Port/9   2/22/10 7:12p robertwm
# SW7405-3949: DirectFB: Add option to build DirectFB-examples.
#
# DirectFB_1_4_Port/8   2/22/10 11:20a robertwm
# SW7420-549: Separate heap for graphics doesn't work with 7420.
#
# DirectFB_1_4_Port/7   2/19/10 12:13p robertwm
# SW7405-3943: DirectFB: Depopulate DirectFB target installation root.
#
# DirectFB_1_4_Port/6   2/18/10 5:59p robertwm
# SW7405-3934: DirectFB: pkg-config does not return the correct cflags or
#  libs used to build DirectFB or SaWMan.
#              (now updated to also include FusionDale and ++DFB).
#
# DirectFB_1_4_Port/5   2/18/10 2:16p robertwm
# SW7405-3931: DirectFB: Missing zlib when building SaWMan with
#  DIRECTFB_SHARED=y.
# SW7405-3932: DirectFB: Refactor build system so that target
#  dependencies are taken into account.
# SW7405-3934: DirectFB: pkg-config does not return the correct cflags or
#  libs used to build DirectFB or SaWMan.
# SW7405-3935: DirectFB: Cannot build DirectFB in multi-application
#  release mode.
#
# DirectFB_1_4_Port/4   1/4/10 5:45p robertwm
# SW7420-523: DirectFB: Require 1080p resolution support.
#
# DirectFB_1_4_Port/3   12/22/09 4:04p robertwm
# SW7405-3657: DirectFB: Add support for building ++DFB.
#
# DirectFB_1_4_Port/2   12/18/09 8:36p robertwm
# SW7405-3636: DirectFB: Create DirectFB-1.4.1 Phase 1.5 Release
#
# DirectFB_1_4_Port/1   12/4/09 1:16p robertwm
# SW7405-3548: DirectFB: Create commom include Makefile
#
############################################################

# We base a lot of things on the particular platform we compiling for.
# This variable MUST be defined in order to continue.  Make sure it is!
ifndef NEXUS_PLATFORM
ifndef PLATFORM
$(error NEXUS_PLATFORM environment variable is required)
else
NEXUS_PLATFORM := $(PLATFORM)
endif
endif

#
# Check to ensure BCHP_VER is defined in the environment
#
ifeq ($(BCHP_VER),)
$(error BCHP_VER enironment variable not defined)
endif

ifndef NEXUS_TOP
$(error NEXUS_TOP is not defined)
endif

ifndef APPLIBS_TOP
$(error APPLIBS_TOP is not defined)
endif

#
# This is the default location of the linux kernel source.
# This can be a symlink to your latest version of kernel source.
#
LINUX ?= /opt/brcm/linux

#
# Check for presence of LINUX/Makefile.
#
ifneq ($(shell test -e ${LINUX}/Makefile && echo "y"),y)
$(error Cannot find ${LINUX}/Makefile.  Please set LINUX environment variable to point to your kernel source tree)
endif

##
#
# Ensure envars are backward compatible
#
ifdef MODE
NEXUS_MODE ?= $(MODE)
endif
ifdef OS
B_REFSW_OS ?= $(OS)
endif
ifdef DEBUG
B_REFSW_DEBUG ?= $(DEBUG)
endif
ifdef VERBOSE
B_REFSW_VERBOSE ?= $(VERBOSE)
endif
ifdef ARCH
B_REFSW_ARCH ?= $(ARCH)
endif
ifdef SHAREABLE
B_REFSW_SHAREABLE ?= $(SHAREABLE)
endif
ifdef BLUETOOTH_INPUT
B_REFSW_BSALIB ?= $(BLUETOOTH_INPUT)
endif

ifeq ($(B_REFSW_OS),)
B_REFSW_OS = linuxuser
endif

ifeq ($(B_REFSW_DEBUG),)
B_REFSW_DEBUG = y
endif

ifeq ($(B_REFSW_ARCH),)
B_REFSW_ARCH = mipsel-linux-uclibc
endif

ifeq ($(B_REFSW_DEBUG),y)
B_REFSW_BUILD_TYPE ?= debug
else
B_REFSW_BUILD_TYPE ?= release
endif

#
# Set variables based on the toolchain
#
ifeq ($(B_REFSW_ARCH),i386-linux)
B_REFSW_CROSS_COMPILE ?=
else
B_REFSW_CROSS_COMPILE ?= $(B_REFSW_ARCH)-

# Define make variables
AS      = $(B_REFSW_CROSS_COMPILE)as
LD      = $(B_REFSW_CROSS_COMPILE)ld
CC      = $(B_REFSW_CROSS_COMPILE)gcc
# NOTE: We must use c++ and not g++ to avoid GPL contamination
CXX     = $(B_REFSW_CROSS_COMPILE)c++
AR      = $(B_REFSW_CROSS_COMPILE)ar
NM      = $(B_REFSW_CROSS_COMPILE)nm
STRIP   = $(B_REFSW_CROSS_COMPILE)strip
OBJCOPY = $(B_REFSW_CROSS_COMPILE)objcopy
OBJDUMP = $(B_REFSW_CROSS_COMPILE)objdump
RANLIB  = $(B_REFSW_CROSS_COMPILE)ranlib

endif

BCHP_VER_LOWER ?= $(shell awk 'BEGIN{print tolower("$(BCHP_VER)")}')
DATE           ?= $(shell date +%Y%m%d)

#
# Define Nexus driver kernel module and script
#
ifneq ($(NEXUS_MODE),proxy)
NEXUS_DRIVER   = bcmdriver.ko
NEXUS_LIB      = libnexus_user.so
NEXUS_SCRIPT   = nexus_user.974xx
else
NEXUS_DRIVER   = nexus.ko
NEXUS_LIB      = libnexus_kernel.so
NEXUS_SCRIPT   = nexus_kernel.974xx
endif

##
#
# Point to AppLibs target output dirs
#
APPLIBS_INSTALL_PREFIX  ?= /usr/local
APPLIBS_TARGET_TOP      ?= ${APPLIBS_TOP}/target
APPLIBS_TARGET_ROOT_DIR ?= ${APPLIBS_TARGET_TOP}/${NEXUS_PLATFORM}${BCHP_VER_LOWER}.${B_REFSW_ARCH}.${B_REFSW_BUILD_TYPE}
APPLIBS_TARGET_DIR      ?= ${APPLIBS_TARGET_ROOT_DIR}/${APPLIBS_INSTALL_PREFIX}
APPLIBS_TARGET_LIB_DIR  ?= ${APPLIBS_TARGET_DIR}/lib
APPLIBS_TARGET_MOD_DIR  ?= ${APPLIBS_TARGET_LIB_DIR}/modules
APPLIBS_TARGET_BIN_DIR  ?= ${APPLIBS_TARGET_DIR}/bin
APPLIBS_TARGET_INC_DIR  ?= ${APPLIBS_TARGET_DIR}/include

##
#
# Point to opensource top dirs
#
OPENSOURCE_TOP ?= ${APPLIBS_TOP}/opensource

##
#
# Ensure toolchain used to build utilities is correct
#
B_REFSW_TOOLCHAIN_ARCH = $(shell echo $(B_REFSW_ARCH) | cut -d- -f1)-linux

##
#
# Add in additional include paths if required
#
NEXUS_APP_INCLUDE_PATHS +=                      \
    $(MAGNUM)/basemodules/int                   \
    $(MAGNUM)/basemodules/int/$(BCHP_CHIP)      \
    $(MAGNUM)/basemodules/mem                   \
    $(MAGNUM)/commonutils/pxl                   \
    $(MAGNUM)/commonutils/sur/$(BCHP_CHIP)


ifneq ($(findstring NEXUS_HAS_GRAPHICS3D, $(NEXUS_APP_DEFINES)),)
ifeq ($(NEXUS_MODE),proxy)
$(warning *** Support for 3D graphics / OpenGL ES 1.0 with drivers in kernel space is not available. ***)
endif
NEXUS_APP_INCLUDE_PATHS +=                                      \
    $(NEXUS_SYNCTHUNK_DIR)                                      \
    $(NEXUS_TOP)/base/include                                   \
    $(NEXUS_TOP)/base/include/$(B_REFSW_OS)                     \
    $(NEXUS_TOP)/modules/surface/$(BCHP_CHIP)/include/priv      \
    $(NEXUS_TOP)/modules/graphics2d/$(BCHP_CHIP)/src            \
    $(NEXUS_TOP)/modules/graphics3d/$(BCHP_CHIP)/include/priv   \
    $(MAGNUM)/basemodules/tmr/$(BCHP_CHIP)                      \
    $(MAGNUM)/commonutils/avc/$(BCHP_CHIP)                      \
    $(MAGNUM)/commonutils/mrc/$(BCHP_CHIP)                      \
    $(MAGNUM)/commonutils/fmt                                   \
    $(MAGNUM)/portinginterface/grc/$(BCHP_CHIP)                 \
    $(MAGNUM)/portinginterface/p3d/$(BCHP_CHIP)
endif

##
#
# Support Extra Targets for building
#
EXTRA_BUILD_TARGETS                            +=
EXTRA_CLEAN_TARGETS                            +=
EXTRA_DISTCLEAN_TARGETS                        +=
EXTRA_UNINSTALL_TARGETS                        +=
EXTRA_CONFIGURED_TARGETS                       +=
EXTRA_COMPILED_TARGETS                         +=
EXTRA_INSTALLED_TARGETS                        +=
EXTRA_TARGET_INSTALLED_TARGETS                 +=

#
# Work out Kernel Version from Kernel Source's Top Level Makefile
#
K_VERSION                                      := $(shell grep -m1 "^VERSION" ${LINUX}/Makefile      | cut -d= -f2- | sed -e "s;^[^[:digit:]]*;;")
K_PATCHLEVEL                                   := $(shell grep -m1 "^PATCHLEVEL" ${LINUX}/Makefile   | cut -d= -f2- | sed -e "s;^[^[:digit:]]*;;")
K_SUBLEVEL                                     := $(shell grep -m1 "^SUBLEVEL" ${LINUX}/Makefile     | cut -d= -f2- | sed -e "s;^[^[:digit:]]*;;")
K_EXTRAVERSION                                 := '$(shell grep -m1 "^EXTRAVERSION" ${LINUX}/Makefile | cut -d= -f2-)'
ifneq ($(findstring shell,${K_EXTRAVERSION}),)
K_EXTRAVERSION                                 :=
else
K_EXTRAVERSION                                 := $(shell echo ${K_EXTRAVERSION} | sed -e "s;^[^[:digit:]]*;;")
endif
KERNEL_VERSION                                 := ${K_VERSION}.${K_PATCHLEVEL}.${K_SUBLEVEL}
ifneq ($(K_EXTRAVERSION),)
KERNEL_VERSION                                 := ${KERNEL_VERSION}-${K_EXTRAVERSION}
endif

#
# DirectFB Core Specific Defines
#
DIRECTFB_VERSION                               ?= 1.4.5
DIRECTFB_MAJOR                                 := $(shell echo ${DIRECTFB_VERSION} | cut -d. -f1)
DIRECTFB_MINOR                                 := $(shell echo ${DIRECTFB_VERSION} | cut -d. -f2)
DIRECTFB_MICRO                                 := $(shell echo ${DIRECTFB_VERSION} | cut -d. -f3)
DIRECTFB_VERSION_VENDOR                        := Phase 1.5.1
DIRECTFB_GFX_MAJOR_VERSION                     := 3
DIRECTFB_GFX_MINOR_VERSION                     := 3
DIRECTFB_SYS_MAJOR_VERSION                     := 4
DIRECTFB_SYS_MINOR_VERSION                     := 0
DIRECTFB_APP_MAJOR_VERSION                     := 1
DIRECTFB_APP_MINOR_VERSION                     := 0
DIRECTFB_APPLIBS                               ?= y
DIRECTFB_SHARED                                ?= y
DIRECTFB_MULTI                                 ?= n
DIRECTFB_SW_SMOOTH_SCALING                     ?= n
DIRECTFB_SW_DITHERING                          ?= y
DIRECTFB_LINOTYPE                              ?= n
DIRECTFB_GLES_SUPPORT                          ?= n
ifneq ($(shell grep -w NEXUS_IrInputMode_eBrcmGeneric ${NEXUS_TOP}/modules/ir_input/${BCHP_CHIP}/include/nexus_ir_input.h),)
DIRECTFB_IR_PROTOCOL                           ?= BrcmGeneric
DIRECTFB_IR_KEYCODES                           ?= generic
else
DIRECTFB_IR_PROTOCOL                           ?= RemoteA
DIRECTFB_IR_KEYCODES                           ?= remotea
endif
DIRECTFB_BT_KEYCODES_FILE                      ?= bcmnexus_bt_keycodes_generic.h
DIRECTFB_GFX_PACKET_BUFFER                     ?= y
DIRECTFB_GFX_TRAPEZOID_SUPPORT                 ?= y
DIRECTFB_GFX_SOFT_MATRIX_SUPPORT               ?= y
USE_SHIM                                       ?= n
BUILD_TESTS                                    ?= n
BUILD_EXAMPLES                                 ?= n
BUILD_FUSION                                   ?= n
BUILD_FUSIONDALE                               ?= n
BUILD_SAWMAN                                   ?= n
BUILD_PPDFB                                    ?= n
BUILD_DIVINE                                   ?= n
BUILD_VOODOO                                   ?= ${BUILD_DIVINE}
BUILD_INSIGNIA                                 ?= n
BUILD_TACHO                                    ?= n


DIRECTFB_SOURCE_TARBALL                        := DirectFB-$(DIRECTFB_VERSION).tar.gz
DIRECTFB_PREFIX                                ?= ${APPLIBS_INSTALL_PREFIX}
DIRECTFB_DIR                                   := $(OPENSOURCE_TOP)/directfb
DIRECTFB_BIN_DIR                               := ${DIRECTFB_DIR}/bin
DIRECTFB_DOCS_DIR                              := ${DIRECTFB_DIR}/docs
DIRECTFB_SRC_DIR                               := ${DIRECTFB_DIR}/src
DIRECTFB_SRC_DFB_TAR_DIR                       := ${DIRECTFB_SRC_DIR}/directfb_tarballs
DIRECTFB_SRC_BRCM_DIR                          := ${DIRECTFB_SRC_DIR}/broadcom_files
DIRECTFB_PRE_DIR                               := ${DIRECTFB_SRC_BRCM_DIR}/precompiled
DIRECTFB_PRE_INSTALL_DIR                       := ${DIRECTFB_PRE_DIR}/${NEXUS_PLATFORM}${BCHP_VER_LOWER}_${B_REFSW_ARCH}_${KERNEL_VERSION}
ifeq ($(SMP),y)
DIRECTFB_PRE_INSTALL_DIR                       := ${DIRECTFB_PRE_INSTALL_DIR}-smp
endif
DIRECTFB_PRE_INSTALL_DIR                       := ${DIRECTFB_PRE_INSTALL_DIR}_${B_REFSW_BUILD_TYPE}
DIRECTFB_PUB_DIR                               := ${DIRECTFB_SRC_BRCM_DIR}/public
DIRECTFB_PRI_DIR                               := ${DIRECTFB_SRC_BRCM_DIR}/private
DIRECTFB_PRE_INSTALL_BIN_DIR                   := ${DIRECTFB_PRE_INSTALL_DIR}/bin
DIRECTFB_PRE_INSTALL_BIN_DFB_DIR               := ${DIRECTFB_PRE_INSTALL_BIN_DIR}/directfb
DIRECTFB_PRE_INSTALL_BIN_DFB_VER_DIR           := ${DIRECTFB_PRE_INSTALL_BIN_DFB_DIR}/${DIRECTFB_MAJOR}.${DIRECTFB_MINOR}
DIRECTFB_PRE_INSTALL_ETC_DIR                   := ${DIRECTFB_PRE_INSTALL_DIR}/etc
DIRECTFB_PRE_INSTALL_INCLUDE_DIR               := ${DIRECTFB_PRE_INSTALL_DIR}/include
DIRECTFB_PRE_INSTALL_LIB_DIR                   := ${DIRECTFB_PRE_INSTALL_DIR}/lib
ifneq ($(DIRECTFB_VERSION),1.4.1)
DIRECTFB_PRE_INSTALL_LIB_DFB_DIR               := ${DIRECTFB_PRE_INSTALL_LIB_DIR}/directfb-${DIRECTFB_MAJOR}.${DIRECTFB_MINOR}-${DIRECTFB_MICRO}
else
DIRECTFB_PRE_INSTALL_LIB_DFB_DIR               := ${DIRECTFB_PRE_INSTALL_LIB_DIR}/directfb-${DIRECTFB_MAJOR}.${DIRECTFB_MINOR}-0
endif
ifneq ($(B_REFSW_DEBUG),y)
DIRECTFB_PRE_INSTALL_LIB_DFB_DIR               := ${DIRECTFB_PRE_INSTALL_LIB_DFB_DIR}-pure
endif
DIRECTFB_PRE_INSTALL_LIB_DFB_GFX_DIR           := ${DIRECTFB_PRE_INSTALL_LIB_DFB_DIR}/gfxdrivers
DIRECTFB_PRE_INSTALL_LIB_DFB_SYS_DIR           := ${DIRECTFB_PRE_INSTALL_LIB_DFB_DIR}/systems
DIRECTFB_PRE_INSTALL_LIB_DFB_INP_DIR           := ${DIRECTFB_PRE_INSTALL_LIB_DFB_DIR}/inputdrivers
DIRECTFB_PRE_INSTALL_LIB_DFB_IMG_DIR           := ${DIRECTFB_PRE_INSTALL_LIB_DFB_DIR}/interfaces/IDirectFBImageProvider
DIRECTFB_PRE_INSTALL_LIB_MODULES_DIR           := ${DIRECTFB_PRE_INSTALL_LIB_DIR}/modules
DIRECTFB_PUB_DFB_DIR                           := ${DIRECTFB_PUB_DIR}/DirectFB
DIRECTFB_PUB_DFB_VER1_DIR                      := ${DIRECTFB_PUB_DFB_DIR}/${DIRECTFB_MAJOR}.${DIRECTFB_MINOR}
DIRECTFB_PUB_DFB_VER2_DIR                      := ${DIRECTFB_PUB_DFB_VER1_DIR}.${DIRECTFB_MICRO}
DIRECTFB_PRI_DFB_DIR                           := ${DIRECTFB_PRI_DIR}/DirectFB
DIRECTFB_PRI_DFB_VER1_DIR                      := ${DIRECTFB_PRI_DFB_DIR}/${DIRECTFB_MAJOR}.${DIRECTFB_MINOR}
DIRECTFB_PRI_DFB_VER2_DIR                      := ${DIRECTFB_PRI_DFB_VER1_DIR}.${DIRECTFB_MICRO}
DIRECTFB_SRC_DFB_DIR                           := ${DIRECTFB_SRC_DIR}/DirectFB-${DIRECTFB_VERSION}
DIRECTFB_INCLUDE_DIR                           := ${DIRECTFB_SRC_DFB_DIR}/include
DIRECTFB_LIB_DIR                               := ${DIRECTFB_SRC_DFB_DIR}/lib
DIRECTFB_BUILD_DIR                             := ${DIRECTFB_DIR}/build
DIRECTFB_BUILD_VER_DIR                         := ${DIRECTFB_BUILD_DIR}/$(DIRECTFB_VERSION)
DIRECTFB_OBJECT_DIR                            := $(DIRECTFB_BUILD_VER_DIR)/$(NEXUS_PLATFORM)_$(B_REFSW_OS)
DIRECTFB_TARGET_ROOT_DIR                       ?= ${DIRECTFB_PREFIX}
DIRECTFB_TARGET_BIN_DIR                        := ${DIRECTFB_TARGET_ROOT_DIR}/bin
DIRECTFB_TARGET_BIN_DFB_DIR                    := ${DIRECTFB_TARGET_BIN_DIR}/directfb
DIRECTFB_TARGET_BIN_DFB_VER_DIR                := ${DIRECTFB_TARGET_BIN_DFB_DIR}/${DIRECTFB_MAJOR}.${DIRECTFB_MINOR}
DIRECTFB_TARGET_LIB_DIR                        := ${DIRECTFB_TARGET_ROOT_DIR}/lib
DIRECTFB_TARGET_MODULES_DIR                    := ${DIRECTFB_TARGET_LIB_DIR}/modules
DIRECTFB_GFX_DEFINES_FILE                      := ${DIRECTFB_SRC_DFB_DIR}/gfxdrivers/bcmnexus/bcmnexus_gfx_defines.h
DIRECTFB_SYS_DEFINES_FILE                      := ${DIRECTFB_SRC_DFB_DIR}/systems/bcmnexus/bcmnexus_sys_defines.h
DIRECTFB_APP_DEFINES_FILE                      := ${DIRECTFB_SRC_DFB_DIR}/tools/bcmnexus_app_defines.h
DIRECTFB_IR_INPUTMODE_FILE                     := ${DIRECTFB_SRC_DFB_DIR}/inputdrivers/bcmnexus/core/bcmnexus_ir_inputmode.h
DIRECTFB_INSTALL_PREFIX                        := DirectFB-${DIRECTFB_VERSION}_
ifeq ($(DIRECTFB_MULTI),y)
DIRECTFB_INSTALL_PREFIX                        := ${DIRECTFB_INSTALL_PREFIX}multi_
endif
DIRECTFB_INSTALL_PREFIX                        := ${DIRECTFB_INSTALL_PREFIX}${B_REFSW_BUILD_TYPE}_build.${NEXUS_PLATFORM}${BCHP_VER}
DIRECTFB_INSTALL_DIR                           ?= ${DIRECTFB_BIN_DIR}/${DIRECTFB_INSTALL_PREFIX}
DIRECTFB_INSTALL_ROOT_DIR                      := ${DIRECTFB_INSTALL_DIR}/${DIRECTFB_TARGET_ROOT_DIR}
DIRECTFB_INSTALL_BIN_DIR                       := ${DIRECTFB_INSTALL_DIR}/${DIRECTFB_TARGET_BIN_DIR}
DIRECTFB_INSTALL_BIN_DFB_DIR                   := ${DIRECTFB_INSTALL_DIR}/${DIRECTFB_TARGET_BIN_DFB_DIR}
DIRECTFB_INSTALL_BIN_DFB_VER_DIR               := ${DIRECTFB_INSTALL_DIR}/${DIRECTFB_TARGET_BIN_DFB_VER_DIR}
DIRECTFB_INSTALL_ETC_DIR                       := ${DIRECTFB_INSTALL_ROOT_DIR}/etc
DIRECTFB_INSTALL_INCLUDE_DIR                   := ${DIRECTFB_INSTALL_ROOT_DIR}/include
DIRECTFB_INSTALL_LIB_DIR                       := ${DIRECTFB_INSTALL_ROOT_DIR}/lib
DIRECTFB_INSTALL_LIB_MODULES_DIR               := ${DIRECTFB_INSTALL_LIB_DIR}/modules
ifneq ($(DIRECTFB_VERSION),1.4.1)
DIRECTFB_INSTALL_LIB_DFB_DIR                   := ${DIRECTFB_INSTALL_LIB_DIR}/directfb-${DIRECTFB_MAJOR}.${DIRECTFB_MINOR}-${DIRECTFB_MICRO}
else
DIRECTFB_INSTALL_LIB_DFB_DIR                   := ${DIRECTFB_INSTALL_LIB_DIR}/directfb-${DIRECTFB_MAJOR}.${DIRECTFB_MINOR}-0
endif
ifneq ($(B_REFSW_DEBUG),y)
DIRECTFB_INSTALL_LIB_DFB_DIR                   := ${DIRECTFB_INSTALL_LIB_DFB_DIR}-pure
endif
DIRECTFB_INSTALL_LIB_DFB_GFX_DIR               := ${DIRECTFB_INSTALL_LIB_DFB_DIR}/gfxdrivers
DIRECTFB_INSTALL_LIB_DFB_SYS_DIR               := ${DIRECTFB_INSTALL_LIB_DFB_DIR}/systems
DIRECTFB_INSTALL_LIB_DFB_INP_DIR               := ${DIRECTFB_INSTALL_LIB_DFB_DIR}/inputdrivers
DIRECTFB_INSTALL_LIB_DFB_IMG_DIR               := ${DIRECTFB_INSTALL_LIB_DFB_DIR}/interfaces/IDirectFBImageProvider
DIRECTFB_INSTALL_SHARE_DIR                     := ${DIRECTFB_INSTALL_ROOT_DIR}/share
DIRECTFB_INSTALL_DATA_DIR                      := ${DIRECTFB_INSTALL_SHARE_DIR}/directfb-${DIRECTFB_VERSION}
DIRECTFB_INSTALL_MAN_DIR                       := ${DIRECTFB_INSTALL_SHARE_DIR}/man
DIRECTFB_INSTALL_DIRECTFB_INCLUDE_DIR          := ${DIRECTFB_INSTALL_INCLUDE_DIR}/directfb
DIRECTFB_INSTALL_DIRECTFB_INTERNAL_INCLUDE_DIR := ${DIRECTFB_INSTALL_INCLUDE_DIR}/directfb-internal
DIRECTFB_INSTALL_PKG_CONFIG_DIR                := ${DIRECTFB_INSTALL_LIB_DIR}/pkgconfig
DIRECTFB_PKG_CONFIG                            := directfb-internal
DIRECTFB_UNPACKED_FLAG                         := ${DIRECTFB_SRC_DFB_DIR}/.unpacked
DIRECTFB_CONFIGURATION_FLAG                    := ${DIRECTFB_SRC_DFB_DIR}/.configuration
DIRECTFB_CONFIGURED_FLAG                       := ${DIRECTFB_SRC_DFB_DIR}/.configured
DIRECTFB_COMPILED_FLAG                         := ${DIRECTFB_SRC_DFB_DIR}/.compiled
DIRECTFB_INSTALLED_FLAG                        := ${DIRECTFB_INSTALL_ROOT_DIR}/.directfb_installed
DIRECTFB_POST_INSTALLED_FLAG                   := ${DIRECTFB_INSTALL_ROOT_DIR}/.directfb_post_installed
DIRECTFB_FLAG                                  := ${DIRECTFB_INSTALL_ROOT_DIR}/.directfb

#
# Tarballs
#
DIRECTFB_TARGET_TARBALL                        := ${DIRECTFB_BIN_DIR}/${DIRECTFB_INSTALL_PREFIX}.tgz
DIRECTFB_RELEASE_TARBALL                       := ${DIRECTFB_BIN_DIR}/DirectFB-${DIRECTFB_VERSION}
ifneq ($(DIRECTFB_VERSION_VENDOR),)
DIRECTFB_RELEASE_TARBALL                       := ${DIRECTFB_RELEASE_TARBALL}_${DIRECTFB_VERSION_VENDOR}
endif
DIRECTFB_RELEASE_TARBALL                       := ${DIRECTFB_RELEASE_TARBALL}_${DATE}.tgz
DIRECTFB_RELEASE_TARBALL                       := $(shell echo -n $(DIRECTFB_RELEASE_TARBALL) | sed -e "s;\ ;_;g")

DIRECTFB_LIMITED_TARBALL                       := ${DIRECTFB_BIN_DIR}/DirectFB-${DIRECTFB_VERSION}_Limited
ifneq ($(DIRECTFB_VERSION_VENDOR),)
DIRECTFB_LIMITED_TARBALL                       := ${DIRECTFB_LIMITED_TARBALL}_${DIRECTFB_VERSION_VENDOR}
endif
DIRECTFB_LIMITED_TARBALL                       := ${DIRECTFB_LIMITED_TARBALL}_${DATE}.tgz
DIRECTFB_LIMITED_TARBALL                       := $(shell echo -n $(DIRECTFB_LIMITED_TARBALL) | sed -e "s;\ ;_;g")

#
# DirectFB Configuration Flags
#
DIRECTFB_CONFIG_FLAGS                          +=               \
    DIRECTFB_VERSION_VENDOR=" ${DIRECTFB_VERSION_VENDOR}"       \
    --prefix=${DIRECTFB_TARGET_ROOT_DIR}                        \
    --bindir=${DIRECTFB_TARGET_BIN_DFB_VER_DIR}                 \
    --disable-fbdev --disable-sdl --disable-vnc --disable-x11   \
    --enable-jpeg --enable-zlib --enable-png --enable-gif       \
    --enable-freetype                                           \
    --disable-video4linux --disable-devmem                      \
    --host=$(B_REFSW_TOOLCHAIN_ARCH)

DIRECTFB_INPUTDRIVERS := linuxinput

ifneq ($(findstring NEXUS_HAS_KEYPAD, $(NEXUS_APP_DEFINES)),)
DIRECTFB_KEY_INPUT                             ?= $(shell test -d "$(DIRECTFB_PRI_DFB_VER2_DIR)/inputdrivers/bcmnexus" && echo "y" || echo "n")
else
DIRECTFB_KEY_INPUT                             := n
endif

ifeq ($(DIRECTFB_KEY_INPUT),y)
DIRECTFB_INPUTDRIVERS := ${DIRECTFB_INPUTDRIVERS},bcmnexus_key
endif

ifneq ($(findstring NEXUS_HAS_IR_INPUT, $(NEXUS_APP_DEFINES)),)
DIRECTFB_IR_INPUT                              ?= $(shell test -d "$(DIRECTFB_PRI_DFB_VER2_DIR)/inputdrivers/bcmnexus" && echo "y" || echo "n")
else
DIRECTFB_IR_INPUT                              := n
endif

ifeq ($(DIRECTFB_IR_INPUT),y)
DIRECTFB_INPUTDRIVERS := ${DIRECTFB_INPUTDRIVERS},bcmnexus_ir
DIRECTFB_CONFIG_FLAGS += DIRECTFB_IR_PROTOCOL=${DIRECTFB_IR_PROTOCOL}
DIRECTFB_CONFIG_FLAGS += DIRECTFB_IR_KEYCODES=${DIRECTFB_IR_KEYCODES}
endif

ifeq ($(B_REFSW_BSALIB),y)
DIRECTFB_BT_INPUT                              ?= $(shell test -d "$(DIRECTFB_PRI_DFB_VER2_DIR)/inputdrivers/bcmnexus" && echo "y" || echo "n")
else
DIRECTFB_BT_INPUT                              := n
endif

ifeq ($(DIRECTFB_BT_INPUT),y)
DIRECTFB_INPUTDRIVERS := ${DIRECTFB_INPUTDRIVERS},bcmnexus_bt
DIRECTFB_CONFIG_FLAGS += DIRECTFB_BT_KEYCODES_FILE=${DIRECTFB_BT_KEYCODES_FILE}
endif

DIRECTFB_CONFIG_FLAGS += --with-inputdrivers=${DIRECTFB_INPUTDRIVERS}

DIRECTFB_SYSTEM ?= $(shell test -d "$(DIRECTFB_PRI_DFB_VER2_DIR)/systems/bcmnexus" && echo "y" || echo "n")

ifeq ($(BUILD_TESTS),y)
DIRECTFB_CONFIG_FLAGS += --with-tests
endif

ifeq ($(DIRECTFB_SYSTEM),y)
DIRECTFB_CONFIG_FLAGS += --enable-bcmnexus

# Check whether Nexus has 3D graphics support enabled first
ifneq ($(findstring NEXUS_HAS_GRAPHICS3D, $(NEXUS_APP_DEFINES)),)
ifeq ($(DIRECTFB_GLES_SUPPORT),y)
ifeq ($(shell test -f "${MAGNUM}/portinginterface/p3d/${BCHP_CHIP}/bp3d_private.h" && echo "y"),y)
DIRECTFB_CONFIG_FLAGS += --enable-bcmnexus-gles --enable-egl
endif
endif
endif

endif

ifeq ($(DIRECTFB_SHARED),y)
DIRECTFB_CONFIG_FLAGS += --enable-shared-extlibs
endif

ifneq (($(findstring NEXUS_HAS_GRAPHICS2D, $(NEXUS_APP_DEFINES)),), ($(findstring NEXUS_HAS_ZSP_GRAPHICS, $(NEXUS_APP_DEFINES)),))
DIRECTFB_ACCEL                                 ?= $(shell test -d "$(DIRECTFB_PRI_DFB_VER2_DIR)/gfxdrivers/bcmnexus" && echo "y" || echo "n")
else
DIRECTFB_ACCEL                                 := n
endif

ifeq ($(DIRECTFB_ACCEL),y)
DIRECTFB_CONFIG_FLAGS += --with-gfxdrivers=bcmnexus
else
DIRECTFB_CONFIG_FLAGS += --with-gfxdrivers=none
endif

ifeq ($(DIRECTFB_MULTI),y)
BUILD_FUSION = y
BUILD_SAWMAN = y
endif

ifeq ($(DIRECTFB_MULTI),y)
DIRECTFB_CONFIG_FLAGS += --enable-multi
endif

ifneq ($(findstring NEXUS_HAS_PICTURE_DECODER, $(NEXUS_APP_DEFINES)),)
DIRECTFB_SID ?= $(shell test -d "$(DIRECTFB_PRI_DFB_VER2_DIR)/interfaces/IDirectFBImageProvider" && echo "y" || echo "n")
else
DIRECTFB_SID := n
endif

ifeq ($(DIRECTFB_SID),y)
DIRECTFB_CONFIG_FLAGS += --enable-sid
endif

ifeq ($(DIRECTFB_SW_SMOOTH_SCALING),y)
DIRECTFB_CONFIG_FLAGS += --with-smooth-scaling
endif

ifeq ($(DIRECTFB_SW_DITHERING),y)
DIRECTFB_CONFIG_FLAGS += --with-dither-rgb16=advanced --with-dither=advanced
endif

ifeq ($(DIRECTFB_LINOTYPE),y)
DIRECTFB_LINOTYPE = $(shell test -e "$(DIRECTFB_SRC_DFB_DIR)/interfaces/IDirectFBFont/idirectfbfont_lino.c" && echo "y" || echo "n")
endif

ifeq ($(DIRECTFB_LINOTYPE),y)
DIRECTFB_CONFIG_FLAGS += --enable-linotype
endif

ifeq ($(BUILD_VOODOO),y)
DIRECTFB_CONFIG_FLAGS += --enable-voodoo
endif

ifeq ($(B_REFSW_DEBUG),y)
DIRECTFB_CONFIG_FLAGS += --enable-debug --enable-debug-support
else
DIRECTFB_CONFIG_FLAGS += --disable-debug --disable-debug-support
endif

ifeq ($(TRACE),y)
DIRECTFB_CONFIG_FLAGS += --enable-trace
endif

#
# DirectFB Examples Specific Defines
#
DIRECTFB_EXAMPLES_VERSION                   ?= 1.2.0
DIRECTFB_EXAMPLES_MAJOR                     := $(shell echo ${DIRECTFB_EXAMPLES_VERSION} | cut -d. -f1)
DIRECTFB_EXAMPLES_MINOR                     := $(shell echo ${DIRECTFB_EXAMPLES_VERSION} | cut -d. -f2)
DIRECTFB_EXAMPLES_MICRO                     := $(shell echo ${DIRECTFB_EXAMPLES_VERSION} | cut -d. -f3)
DIRECTFB_EXAMPLES_SOURCE_TARBALL            := DirectFB-examples-$(DIRECTFB_EXAMPLES_VERSION).tar.gz
DIRECTFB_EXAMPLES_TARGET_ROOT_DIR           ?= ${DIRECTFB_PREFIX}
DIRECTFB_EXAMPLES_TARGET_BIN_DIR            := ${DIRECTFB_EXAMPLES_TARGET_ROOT_DIR}/bin
DIRECTFB_EXAMPLES_TARGET_BIN_DFB_DIR        := ${DIRECTFB_EXAMPLES_TARGET_BIN_DIR}/directfb-examples
DIRECTFB_EXAMPLES_TARGET_BIN_DFB_VER_DIR    := ${DIRECTFB_EXAMPLES_TARGET_BIN_DFB_DIR}/${DIRECTFB_EXAMPLES_MAJOR}.${DIRECTFB_EXAMPLES_MINOR}
DIRECTFB_EXAMPLES_PUB_DFB_DIR               := ${DIRECTFB_PUB_DIR}/DirectFB-examples
DIRECTFB_EXAMPLES_PUB_DFB_VER1_DIR          := ${DIRECTFB_EXAMPLES_PUB_DFB_DIR}/${DIRECTFB_EXAMPLES_MAJOR}.${DIRECTFB_EXAMPLES_MINOR}
DIRECTFB_EXAMPLES_PUB_DFB_VER2_DIR          := ${DIRECTFB_EXAMPLES_PUB_DFB_VER1_DIR}.${DIRECTFB_EXAMPLES_MICRO}
DIRECTFB_EXAMPLES_PRI_DFB_DIR               := ${DIRECTFB_PRI_DIR}/DirectFB-examples
DIRECTFB_EXAMPLES_PRI_DFB_VER1_DIR          := ${DIRECTFB_EXAMPLES_PRI_DFB_DIR}/${DIRECTFB_EXAMPLES_MAJOR}.${DIRECTFB_EXAMPLES_MINOR}
DIRECTFB_EXAMPLES_PRI_DFB_VER2_DIR          := ${DIRECTFB_EXAMPLES_PRI_DFB_VER1_DIR}.${DIRECTFB_EXAMPLES_MICRO}
DIRECTFB_EXAMPLES_SRC_DIR                   := ${DIRECTFB_SRC_DIR}/DirectFB-examples-$(DIRECTFB_EXAMPLES_VERSION)
DIRECTFB_EXAMPLES_INCLUDE_DIR               := ${DIRECTFB_EXAMPLES_SRC_DIR}/include
DIRECTFB_EXAMPLES_INSTALL_DIR               ?= ${DIRECTFB_INSTALL_DIR}
DIRECTFB_EXAMPLES_INSTALL_ROOT_DIR          := ${DIRECTFB_EXAMPLES_INSTALL_DIR}/${DIRECTFB_EXAMPLES_TARGET_ROOT_DIR}
DIRECTFB_EXAMPLES_INSTALL_BIN_DIR           := ${DIRECTFB_EXAMPLES_INSTALL_DIR}/${DIRECTFB_EXAMPLES_TARGET_BIN_DIR}
DIRECTFB_EXAMPLES_INSTALL_BIN_DFB_DIR       := ${DIRECTFB_EXAMPLES_INSTALL_DIR}/${DIRECTFB_EXAMPLES_TARGET_BIN_DFB_DIR}
DIRECTFB_EXAMPLES_INSTALL_BIN_DFB_VER_DIR   := ${DIRECTFB_EXAMPLES_INSTALL_DIR}/${DIRECTFB_EXAMPLES_TARGET_BIN_DFB_VER_DIR}
DIRECTFB_EXAMPLES_INSTALL_INCLUDE_DIR       := ${DIRECTFB_EXAMPLES_INSTALL_ROOT_DIR}/include
DIRECTFB_EXAMPLES_INSTALL_LIB_DIR           := ${DIRECTFB_EXAMPLES_INSTALL_ROOT_DIR}/lib
DIRECTFB_EXAMPLES_INSTALL_SHARE_DIR         := ${DIRECTFB_EXAMPLES_INSTALL_ROOT_DIR}/share
DIRECTFB_EXAMPLES_INSTALL_MAN_DIR           := ${DIRECTFB_EXAMPLES_INSTALL_SHARE_DIR}/man
DIRECTFB_EXAMPLES_CONFIG_FLAGS              :=              \
    --prefix=${DIRECTFB_EXAMPLES_TARGET_ROOT_DIR}           \
    --bindir=${DIRECTFB_EXAMPLES_TARGET_BIN_DFB_VER_DIR}    \
    --host=$(B_REFSW_TOOLCHAIN_ARCH)

ifeq ($(B_REFSW_DEBUG),y)
DIRECTFB_EXAMPLES_CONFIG_FLAGS += --enable-debug
endif

DIRECTFB_EXAMPLES_BUILD_TARGET           := directfb-examples-all
DIRECTFB_EXAMPLES_CLEAN_TARGET           := directfb-examples-clean
DIRECTFB_EXAMPLES_DISTCLEAN_TARGET       := directfb-examples-distclean
DIRECTFB_EXAMPLES_MRPROPER_TARGET        := directfb-examples-mrproper
DIRECTFB_EXAMPLES_UNINSTALL_TARGET       := directfb-examples-uninstall
DIRECTFB_EXAMPLES_UNPACKED_FLAG          := ${DIRECTFB_EXAMPLES_SRC_DIR}/.unpacked
DIRECTFB_EXAMPLES_CONFIGURATION_FLAG     := ${DIRECTFB_EXAMPLES_SRC_DIR}/.configuration
DIRECTFB_EXAMPLES_CONFIGURED_FLAG        := ${DIRECTFB_EXAMPLES_SRC_DIR}/.configured
DIRECTFB_EXAMPLES_COMPILED_FLAG          := ${DIRECTFB_EXAMPLES_SRC_DIR}/.compiled
DIRECTFB_EXAMPLES_INSTALLED_FLAG         := ${DIRECTFB_EXAMPLES_INSTALL_ROOT_DIR}/.directfb_examples_installed
DIRECTFB_EXAMPLES_FLAG                   := ${DIRECTFB_EXAMPLES_INSTALL_ROOT_DIR}/.directfb_examples
EXTRA_CLEAN_TARGETS                      += ${DIRECTFB_EXAMPLES_CLEAN_TARGET}
EXTRA_DISTCLEAN_TARGETS                  += ${DIRECTFB_EXAMPLES_DISTCLEAN_TARGET}
EXTRA_MRPROPER_TARGETS                   += ${DIRECTFB_EXAMPLES_MRPROPER_TARGET}
EXTRA_UNINSTALL_TARGETS                  += ${DIRECTFB_EXAMPLES_UNINSTALL_TARGET}
ifeq ($(BUILD_EXAMPLES),y)
EXTRA_BUILD_TARGETS                      += ${DIRECTFB_EXAMPLES_BUILD_TARGET}
EXTRA_CONFIGURED_TARGETS                 += ${DIRECTFB_EXAMPLES_CONFIGURED_FLAG}
EXTRA_COMPILED_TARGETS                   += ${DIRECTFB_EXAMPLES_COMPILED_FLAG}
EXTRA_INSTALLED_TARGETS                  += ${DIRECTFB_EXAMPLES_INSTALLED_FLAG}
EXTRA_TARGET_INSTALLED_TARGETS           += ${DIRECTFB_EXAMPLES_FLAG}
endif

#
# Fusion Specific Defines
#
FUSION_VERSION                      ?= 8.1.1
FUSION_MAJOR                        := $(shell echo ${FUSION_VERSION} | cut -d. -f1)
FUSION_MINOR                        := $(shell echo ${FUSION_VERSION} | cut -d. -f2)
FUSION_MICRO                        := $(shell echo ${FUSION_VERSION} | cut -d. -f3)
FUSION_SOURCE_TARBALL               := linux-fusion-$(FUSION_VERSION).tar.gz
FUSION_PUB_FUS_DIR                  := ${DIRECTFB_PUB_DIR}/linux-fusion
FUSION_PUB_FUS_VER1_DIR             := ${FUSION_PUB_FUS_DIR}/${FUSION_MAJOR}.${FUSION_MINOR}
FUSION_PUB_FUS_VER2_DIR             := ${FUSION_PUB_FUS_VER1_DIR}.${FUSION_MICRO}
FUSION_PRI_FUS_DIR                  := ${DIRECTFB_PRI_DIR}/linux-fusion
FUSION_PRI_FUS_VER1_DIR             := ${FUSION_PRI_FUS_DIR}/${FUSION_MAJOR}.${FUSION_MINOR}
FUSION_PRI_FUS_VER2_DIR             := ${FUSION_PRI_FUS_VER1_DIR}.${FUSION_MICRO}
FUSION_SRC_DIR                      := ${DIRECTFB_SRC_DIR}/driver/linux-fusion-$(FUSION_VERSION)
FUSION_INSTALL_DIR                  ?= $(DIRECTFB_OBJECT_DIR)/fusion_${B_REFSW_ARCH}_linux
ifeq ($(SMP),y)
FUSION_INSTALL_DIR                  := ${FUSION_INSTALL_DIR}-smp
endif
FUSION_INSTALL_DIR                  := ${FUSION_INSTALL_DIR}-${KERNEL_VERSION}
FUSION_INSTALL_INCLUDE_DIR          := $(FUSION_INSTALL_DIR)/include
FUSION_BUILD_TARGET                 := fusion-all
FUSION_CLEAN_TARGET                 := fusion-clean
FUSION_DISTCLEAN_TARGET             := fusion-distclean
FUSION_MRPROPER_TARGET              := fusion-mrproper
FUSION_UNINSTALL_TARGET             := fusion-uninstall
FUSION_UNPACKED_FLAG                := ${FUSION_SRC_DIR}/.unpacked
FUSION_CONFIGURATION_FLAG           := ${FUSION_SRC_DIR}/.configuration
FUSION_COMPILED_FLAG                := ${FUSION_SRC_DIR}/.compiled
FUSION_INSTALLED_FLAG               := ${FUSION_INSTALL_DIR}/.fusion_installed
FUSION_FLAG                         := ${FUSION_INSTALL_DIR}/.fusion

#
# SaWMan Specific Defines
#
SAWMAN_VERSION                      ?= 1.4.5
SAWMAN_MAJOR                        := $(shell echo ${SAWMAN_VERSION} | cut -d. -f1)
SAWMAN_MINOR                        := $(shell echo ${SAWMAN_VERSION} | cut -d. -f2)
SAWMAN_MICRO                        := $(shell echo ${SAWMAN_VERSION} | cut -d. -f3)
SAWMAN_SOURCE_TARBALL               := SaWMan-$(SAWMAN_VERSION).tar.gz
SAWMAN_TARGET_ROOT_DIR              ?= ${DIRECTFB_PREFIX}
SAWMAN_TARGET_BIN_DIR               := ${SAWMAN_TARGET_ROOT_DIR}/bin
SAWMAN_TARGET_BIN_SAW_DIR           := ${SAWMAN_TARGET_BIN_DIR}/sawman
SAWMAN_TARGET_BIN_SAW_VER_DIR       := ${SAWMAN_TARGET_BIN_SAW_DIR}/${SAWMAN_MAJOR}.${SAWMAN_MINOR}
SAWMAN_PUB_SAW_DIR                  := ${DIRECTFB_PUB_DIR}/SaWMan
SAWMAN_PUB_SAW_VER1_DIR             := ${SAWMAN_PUB_SAW_DIR}/${SAWMAN_MAJOR}.${SAWMAN_MINOR}
SAWMAN_PUB_SAW_VER2_DIR             := ${SAWMAN_PUB_SAW_VER1_DIR}.${SAWMAN_MICRO}
SAWMAN_PRI_SAW_DIR                  := ${DIRECTFB_PRI_DIR}/SaWMan
SAWMAN_PRI_SAW_VER1_DIR             := ${SAWMAN_PRI_SAW_DIR}/${SAWMAN_MAJOR}.${SAWMAN_MINOR}
SAWMAN_PRI_SAW_VER2_DIR             := ${SAWMAN_PRI_SAW_VER1_DIR}.${SAWMAN_MICRO}
SAWMAN_SRC_DIR                      := ${DIRECTFB_SRC_DIR}/SaWMan-$(SAWMAN_VERSION)
SAWMAN_INCLUDE_DIR                  := ${SAWMAN_SRC_DIR}/include
SAWMAN_INSTALL_DIR                  ?= ${DIRECTFB_INSTALL_DIR}
SAWMAN_INSTALL_ROOT_DIR             := ${SAWMAN_INSTALL_DIR}/${SAWMAN_TARGET_ROOT_DIR}
SAWMAN_INSTALL_BIN_DIR              := ${SAWMAN_INSTALL_DIR}/${SAWMAN_TARGET_BIN_DIR}
SAWMAN_INSTALL_BIN_SAW_DIR          := ${SAWMAN_INSTALL_DIR}/${SAWMAN_TARGET_BIN_SAW_DIR}
SAWMAN_INSTALL_BIN_SAW_VER_DIR      := ${SAWMAN_INSTALL_DIR}/${SAWMAN_TARGET_BIN_SAW_VER_DIR}
SAWMAN_INSTALL_INCLUDE_DIR          := ${SAWMAN_INSTALL_ROOT_DIR}/include
SAWMAN_INSTALL_LIB_DIR              := ${SAWMAN_INSTALL_ROOT_DIR}/lib
SAWMAN_INSTALL_PKG_CONFIG_DIR       := ${SAWMAN_INSTALL_LIB_DIR}/pkgconfig
SAWMAN_PKG_CONFIG                   := sawman
SAWMAN_CONFIG_FLAGS                 :=          \
    --prefix=${SAWMAN_TARGET_ROOT_DIR}          \
    --bindir=${SAWMAN_TARGET_BIN_SAW_VER_DIR}   \
    --host=$(B_REFSW_TOOLCHAIN_ARCH)

ifeq ($(B_REFSW_DEBUG),y)
SAWMAN_CONFIG_FLAGS += --enable-debug
endif

SAWMAN_BUILD_TARGET                 := sawman-all
SAWMAN_CLEAN_TARGET                 := sawman-clean
SAWMAN_DISTCLEAN_TARGET             := sawman-distclean
SAWMAN_MRPROPER_TARGET              := sawman-mrproper
SAWMAN_UNINSTALL_TARGET             := sawman-uninstall
SAWMAN_UNPACKED_FLAG                := ${SAWMAN_SRC_DIR}/.unpacked
SAWMAN_CONFIGURATION_FLAG           := ${SAWMAN_SRC_DIR}/.configuration
SAWMAN_CONFIGURED_FLAG              := ${SAWMAN_SRC_DIR}/.configured
SAWMAN_COMPILED_FLAG                := ${SAWMAN_SRC_DIR}/.compiled
SAWMAN_INSTALLED_FLAG               := ${SAWMAN_INSTALL_ROOT_DIR}/.sawman_installed
SAWMAN_FLAG                         := ${SAWMAN_INSTALL_ROOT_DIR}/.sawman
EXTRA_CLEAN_TARGETS                 += ${SAWMAN_CLEAN_TARGET}
EXTRA_DISTCLEAN_TARGETS             += ${SAWMAN_DISTCLEAN_TARGET}
EXTRA_MRPROPER_TARGETS              += ${SAWMAN_MRPROPER_TARGET}
EXTRA_UNINSTALL_TARGETS             += ${SAWMAN_UNINSTALL_TARGET}
ifeq ($(BUILD_SAWMAN),y)
EXTRA_BUILD_TARGETS                 += ${SAWMAN_BUILD_TARGET}
EXTRA_CONFIGURED_TARGETS            += ${SAWMAN_CONFIGURED_FLAG}
EXTRA_COMPILED_TARGETS              += ${SAWMAN_COMPILED_FLAG}
EXTRA_INSTALLED_TARGETS             += ${SAWMAN_INSTALLED_FLAG}
EXTRA_TARGET_INSTALLED_TARGETS      += ${SAWMAN_FLAG}
endif

#
# FusionDale Specific Defines
#
FUSIONDALE_VERSION                  ?= 0.8.1
FUSIONDALE_MAJOR                    := $(shell echo ${FUSIONDALE_VERSION} | cut -d. -f1)
FUSIONDALE_MINOR                    := $(shell echo ${FUSIONDALE_VERSION} | cut -d. -f2)
FUSIONDALE_MICRO                    := $(shell echo ${FUSIONDALE_VERSION} | cut -d. -f3)
FUSIONDALE_SOURCE_TARBALL           := FusionDale-$(FUSIONDALE_VERSION).tar.gz
FUSIONDALE_TARGET_ROOT_DIR          ?= ${DIRECTFB_PREFIX}
FUSIONDALE_TARGET_BIN_DIR           := ${FUSIONDALE_TARGET_ROOT_DIR}/bin
FUSIONDALE_TARGET_BIN_FUS_DIR       := ${FUSIONDALE_TARGET_BIN_DIR}/fusiondale
FUSIONDALE_TARGET_BIN_FUS_VER_DIR   := ${FUSIONDALE_TARGET_BIN_FUS_DIR}/${FUSIONDALE_MAJOR}.${FUSIONDALE_MINOR}
FUSIONDALE_PUB_FUS_DIR              := ${DIRECTFB_PUB_DIR}/FusionDale
FUSIONDALE_PUB_FUS_VER1_DIR         := ${FUSIONDALE_PUB_FUS_DIR}/${FUSIONDALE_MAJOR}.${FUSIONDALE_MINOR}
FUSIONDALE_PUB_FUS_VER2_DIR         := ${FUSIONDALE_PUB_FUS_VER1_DIR}.${FUSIONDALE_MICRO}
FUSIONDALE_PRI_FUS_DIR              := ${DIRECTFB_PRI_DIR}/FusionDale
FUSIONDALE_PRI_FUS_VER1_DIR         := ${FUSIONDALE_PRI_FUS_DIR}/${FUSIONDALE_MAJOR}.${FUSIONDALE_MINOR}
FUSIONDALE_PRI_FUS_VER2_DIR         := ${FUSIONDALE_PRI_FUS_VER1_DIR}.${FUSIONDALE_MICRO}
FUSIONDALE_SRC_DIR                  := ${DIRECTFB_SRC_DIR}/FusionDale-$(FUSIONDALE_VERSION)
FUSIONDALE_INCLUDE_DIR              := ${FUSIONDALE_SRC_DIR}/include
FUSIONDALE_INSTALL_DIR              ?= ${DIRECTFB_INSTALL_DIR}
FUSIONDALE_INSTALL_ROOT_DIR         := ${FUSIONDALE_INSTALL_DIR}/${FUSIONDALE_TARGET_ROOT_DIR}
FUSIONDALE_INSTALL_BIN_DIR          := ${FUSIONDALE_INSTALL_DIR}/${FUSIONDALE_TARGET_BIN_DIR}
FUSIONDALE_INSTALL_BIN_FUS_DIR      := ${FUSIONDALE_INSTALL_DIR}/${FUSIONDALE_TARGET_BIN_FUS_DIR}
FUSIONDALE_INSTALL_BIN_FUS_VER_DIR  := ${FUSIONDALE_INSTALL_DIR}/${FUSIONDALE_TARGET_BIN_FUS_VER_DIR}
FUSIONDALE_INSTALL_INCLUDE_DIR      := ${FUSIONDALE_INSTALL_ROOT_DIR}/include
FUSIONDALE_INSTALL_LIB_DIR          := ${FUSIONDALE_INSTALL_ROOT_DIR}/lib
FUSIONDALE_INSTALL_PKG_CONFIG_DIR   := ${FUSIONDALE_INSTALL_LIB_DIR}/pkgconfig
FUSIONDALE_PKG_CONFIG               := fusiondale
FUSIONDALE_CONFIG_FLAGS             :=              \
    --prefix=${FUSIONDALE_TARGET_ROOT_DIR}          \
    --bindir=${FUSIONDALE_TARGET_BIN_FUS_VER_DIR}   \
    --host=$(B_REFSW_TOOLCHAIN_ARCH)

ifeq ($(B_REFSW_DEBUG),y)
FUSIONDALE_CONFIG_FLAGS += --enable-debug
endif

FUSIONDALE_BUILD_TARGET             := fusiondale-all
FUSIONDALE_CLEAN_TARGET             := fusiondale-clean
FUSIONDALE_DISTCLEAN_TARGET         := fusiondale-distclean
FUSIONDALE_MRPROPER_TARGET          := fusiondale-mrproper
FUSIONDALE_UNINSTALL_TARGET         := fusiondale-uninstall
FUSIONDALE_UNPACKED_FLAG            := ${FUSIONDALE_SRC_DIR}/.unpacked
FUSIONDALE_CONFIGURATION_FLAG       := ${FUSIONDALE_SRC_DIR}/.configuration
FUSIONDALE_CONFIGURED_FLAG          := ${FUSIONDALE_SRC_DIR}/.configured
FUSIONDALE_COMPILED_FLAG            := ${FUSIONDALE_SRC_DIR}/.compiled
FUSIONDALE_INSTALLED_FLAG           := ${FUSIONDALE_INSTALL_ROOT_DIR}/.fusiondale_installed
FUSIONDALE_FLAG                     := ${FUSIONDALE_INSTALL_ROOT_DIR}/.fusiondale
EXTRA_CLEAN_TARGETS                 += ${FUSIONDALE_CLEAN_TARGET}
EXTRA_DISTCLEAN_TARGETS             += ${FUSIONDALE_DISTCLEAN_TARGET}
EXTRA_MRPROPER_TARGETS              += ${FUSIONDALE_MRPROPER_TARGET}
EXTRA_UNINSTALL_TARGETS             += ${FUSIONDALE_UNINSTALL_TARGET}
ifeq ($(BUILD_FUSIONDALE),y)
EXTRA_BUILD_TARGETS                 += ${FUSIONDALE_BUILD_TARGET}
EXTRA_CONFIGURED_TARGETS            += ${FUSIONDALE_CONFIGURED_FLAG}
EXTRA_COMPILED_TARGETS              += ${FUSIONDALE_COMPILED_FLAG}
EXTRA_INSTALLED_TARGETS             += ${FUSIONDALE_INSTALLED_FLAG}
EXTRA_TARGET_INSTALLED_TARGETS      += ${FUSIONDALE_FLAG}
endif

#
# ++DFB Specific Defines
#
PPDFB_VERSION                       ?= 1.4.2
PPDFB_MAJOR                         := $(shell echo ${PPDFB_VERSION} | cut -d. -f1)
PPDFB_MINOR                         := $(shell echo ${PPDFB_VERSION} | cut -d. -f2)
PPDFB_MICRO                         := $(shell echo ${PPDFB_VERSION} | cut -d. -f3)
PPDFB_SOURCE_TARBALL                := ++DFB-${PPDFB_VERSION}.tar.gz
PPDFB_TARGET_ROOT_DIR               ?= ${DIRECTFB_PREFIX}
PPDFB_TARGET_BIN_DIR                := ${PPDFB_TARGET_ROOT_DIR}/bin
PPDFB_TARGET_BIN_PPD_DIR            := ${PPDFB_TARGET_BIN_DIR}/++dfb
PPDFB_TARGET_BIN_PPD_VER_DIR        := ${PPDFB_TARGET_BIN_PPD_DIR}/${PPDFB_MAJOR}.${PPDFB_MINOR}
PPDFB_PUB_PPD_DIR                   := ${DIRECTFB_PUB_DIR}/++DFB
PPDFB_PUB_PPD_VER1_DIR              := ${PPDFB_PUB_PPD_DIR}/${PPDFB_MAJOR}.${PPDFB_MINOR}
PPDFB_PUB_PPD_VER2_DIR              := ${PPDFB_PUB_PPD_VER1_DIR}.${PPDFB_MICRO}
PPDFB_PRI_PPD_DIR                   := ${DIRECTFB_PRI_DIR}/++DFB
PPDFB_PRI_PPD_VER1_DIR              := ${PPDFB_PRI_PPD_DIR}/${PPDFB_MAJOR}.${PPDFB_MINOR}
PPDFB_PRI_PPD_VER2_DIR              := ${PPDFB_PRI_PPD_VER1_DIR}.${PPDFB_MICRO}
PPDFB_SRC_DIR                       := ${DIRECTFB_SRC_DIR}/++DFB-${PPDFB_VERSION}
PPDFB_INCLUDE_DIR                   := ${PPDFB_SRC_DIR}/include
PPDFB_INSTALL_DIR                   ?= ${DIRECTFB_INSTALL_DIR}
PPDFB_INSTALL_ROOT_DIR              := ${PPDFB_INSTALL_DIR}/${PPDFB_TARGET_ROOT_DIR}
PPDFB_INSTALL_BIN_DIR               := ${PPDFB_INSTALL_DIR}/${PPDFB_TARGET_BIN_DIR}
PPDFB_INSTALL_BIN_PPD_DIR           := ${PPDFB_INSTALL_DIR}/${PPDFB_TARGET_BIN_PPD_DIR}
PPDFB_INSTALL_BIN_PPD_VER_DIR       := ${PPDFB_INSTALL_DIR}/${PPDFB_TARGET_BIN_PPD_VER_DIR}
PPDFB_INSTALL_INCLUDE_DIR           := ${PPDFB_INSTALL_ROOT_DIR}/include
PPDFB_INSTALL_LIB_DIR               := ${PPDFB_INSTALL_ROOT_DIR}/lib
PPDFB_INSTALL_PKG_CONFIG_DIR        := ${PPDFB_INSTALL_LIB_DIR}/pkgconfig
PPDFB_PKG_CONFIG                    := ++dfb
PPDFB_CONFIG_FLAGS                  :=          \
    --prefix=${PPDFB_TARGET_ROOT_DIR}           \
    --bindir=${PPDFB_TARGET_BIN_PPD_VER_DIR}    \
    --host=$(B_REFSW_TOOLCHAIN_ARCH)            \
    CXXFLAGS=-DDIRECTFB_ENABLE_DEPRECATED

PPDFB_BUILD_TARGET                  := ppdfb-all
PPDFB_CLEAN_TARGET                  := ppdfb-clean
PPDFB_DISTCLEAN_TARGET              := ppdfb-distclean
PPDFB_MRPROPER_TARGET               := ppdfb-mrproper
PPDFB_UNINSTALL_TARGET              := ppdfb-uninstall
PPDFB_UNPACKED_FLAG                 := ${PPDFB_SRC_DIR}/.unpacked
PPDFB_CONFIGURATION_FLAG            := ${PPDFB_SRC_DIR}/.configuration
PPDFB_CONFIGURED_FLAG               := ${PPDFB_SRC_DIR}/.configured
PPDFB_COMPILED_FLAG                 := ${PPDFB_SRC_DIR}/.compiled
PPDFB_INSTALLED_FLAG                := ${PPDFB_INSTALL_ROOT_DIR}/.ppdfb_installed
PPDFB_FLAG                          := ${PPDFB_INSTALL_ROOT_DIR}/.ppdfb
EXTRA_CLEAN_TARGETS                 += ${PPDFB_CLEAN_TARGET}
EXTRA_DISTCLEAN_TARGETS             += ${PPDFB_DISTCLEAN_TARGET}
EXTRA_MRPROPER_TARGETS              += ${PPDFB_MRPROPER_TARGET}
EXTRA_UNINSTALL_TARGETS             += ${PPDFB_UNINSTALL_TARGET}
ifeq ($(BUILD_PPDFB),y)
EXTRA_BUILD_TARGETS                 += ${PPDFB_BUILD_TARGET}
EXTRA_CONFIGURED_TARGETS            += ${PPDFB_CONFIGURED_FLAG}
EXTRA_COMPILED_TARGETS              += ${PPDFB_COMPILED_FLAG}
EXTRA_INSTALLED_TARGETS             += ${PPDFB_INSTALLED_FLAG}
EXTRA_TARGET_INSTALLED_TARGETS      += ${PPDFB_FLAG}
endif

#
# DiVine Specific Defines
#
DIVINE_VERSION                      ?= 0.4.0
DIVINE_MAJOR                        := $(shell echo ${DIVINE_VERSION} | cut -d. -f1)
DIVINE_MINOR                        := $(shell echo ${DIVINE_VERSION} | cut -d. -f2)
DIVINE_MICRO                        := $(shell echo ${DIVINE_VERSION} | cut -d. -f3)
DIVINE_SOURCE_TARBALL               := DiVine-${DIVINE_VERSION}.tar.gz
DIVINE_TARGET_ROOT_DIR              ?= ${DIRECTFB_PREFIX}
DIVINE_TARGET_BIN_DIR               := ${DIVINE_TARGET_ROOT_DIR}/bin
DIVINE_TARGET_BIN_DIV_DIR           := ${DIVINE_TARGET_BIN_DIR}/divine
DIVINE_TARGET_BIN_DIV_VER_DIR       := ${DIVINE_TARGET_BIN_DIV_DIR}/${DIVINE_MAJOR}.${DIVINE_MINOR}
DIVINE_PUB_DIV_DIR                  := ${DIRECTFB_PUB_DIR}/DiVine
DIVINE_PUB_DIV_VER1_DIR             := ${DIVINE_PUB_DIV_DIR}/${DIVINE_MAJOR}.${DIVINE_MINOR}
DIVINE_PUB_DIV_VER2_DIR             := ${DIVINE_PUB_DIV_VER1_DIR}.${DIVINE_MICRO}
DIVINE_PRI_DIV_DIR                  := ${DIRECTFB_PRI_DIR}/DiVine
DIVINE_PRI_DIV_VER1_DIR             := ${DIVINE_PRI_DIV_DIR}/${DIVINE_MAJOR}.${DIVINE_MINOR}
DIVINE_PRI_DIV_VER2_DIR             := ${DIVINE_PRI_DIV_VER1_DIR}.${DIVINE_MICRO}
DIVINE_SRC_DIR                      := ${DIRECTFB_SRC_DIR}/DiVine-${DIVINE_VERSION}
DIVINE_INCLUDE_DIR                  := ${DIVINE_SRC_DIR}/include
DIVINE_INSTALL_DIR                  ?= ${DIRECTFB_INSTALL_DIR}
DIVINE_INSTALL_ROOT_DIR             := ${DIVINE_INSTALL_DIR}/${DIVINE_TARGET_ROOT_DIR}
DIVINE_INSTALL_BIN_DIR              := ${DIVINE_INSTALL_DIR}/${DIVINE_TARGET_BIN_DIR}
DIVINE_INSTALL_BIN_DIV_DIR          := ${DIVINE_INSTALL_DIR}/${DIVINE_TARGET_BIN_DIV_DIR}
DIVINE_INSTALL_BIN_DIV_VER_DIR      := ${DIVINE_INSTALL_DIR}/${DIVINE_TARGET_BIN_DIV_VER_DIR}
DIVINE_INSTALL_INCLUDE_DIR          := ${DIVINE_INSTALL_ROOT_DIR}/include
DIVINE_INSTALL_LIB_DIR              := ${DIVINE_INSTALL_ROOT_DIR}/lib
DIVINE_INSTALL_PKG_CONFIG_DIR       := ${DIVINE_INSTALL_LIB_DIR}/pkgconfig
DIVINE_PKG_CONFIG                   := divine
DIVINE_CONFIG_FLAGS                 :=          \
    --prefix=${DIVINE_TARGET_ROOT_DIR}          \
    --bindir=${DIVINE_TARGET_BIN_DIV_VER_DIR}   \
    --host=$(B_REFSW_TOOLCHAIN_ARCH)

DIVINE_BUILD_TARGET                 := divine-all
DIVINE_CLEAN_TARGET                 := divine-clean
DIVINE_DISTCLEAN_TARGET             := divine-distclean
DIVINE_MRPROPER_TARGET              := divine-mrproper
DIVINE_UNINSTALL_TARGET             := divine-uninstall
DIVINE_UNPACKED_FLAG                := ${DIVINE_SRC_DIR}/.unpacked
DIVINE_CONFIGURATION_FLAG           := ${DIVINE_SRC_DIR}/.configuration
DIVINE_CONFIGURED_FLAG              := ${DIVINE_SRC_DIR}/.configured
DIVINE_COMPILED_FLAG                := ${DIVINE_SRC_DIR}/.compiled
DIVINE_INSTALLED_FLAG               := ${DIVINE_INSTALL_ROOT_DIR}/.divine_installed
DIVINE_FLAG                         := ${DIVINE_INSTALL_ROOT_DIR}/.divine
EXTRA_CLEAN_TARGETS                 += ${DIVINE_CLEAN_TARGET}
EXTRA_DISTCLEAN_TARGETS             += ${DIVINE_DISTCLEAN_TARGET}
EXTRA_MRPROPER_TARGETS              += ${DIVINE_MRPROPER_TARGET}
EXTRA_UNINSTALL_TARGETS             += ${DIVINE_UNINSTALL_TARGET}
ifeq ($(BUILD_DIVINE),y)
EXTRA_BUILD_TARGETS                 += ${DIVINE_BUILD_TARGET}
EXTRA_CONFIGURED_TARGETS            += ${DIVINE_CONFIGURED_FLAG}
EXTRA_COMPILED_TARGETS              += ${DIVINE_COMPILED_FLAG}
EXTRA_INSTALLED_TARGETS             += ${DIVINE_INSTALLED_FLAG}
EXTRA_TARGET_INSTALLED_TARGETS      += ${DIVINE_FLAG}
endif

#
# Insignia Specific Defines
#
INSIGNIA_VERSION                      ?= 0.1.2
INSIGNIA_MAJOR                        := $(shell echo ${INSIGNIA_VERSION} | cut -d. -f1)
INSIGNIA_MINOR                        := $(shell echo ${INSIGNIA_VERSION} | cut -d. -f2)
INSIGNIA_MICRO                        := $(shell echo ${INSIGNIA_VERSION} | cut -d. -f3)
INSIGNIA_SOURCE_TARBALL               := Insignia-${INSIGNIA_VERSION}.tar.gz
INSIGNIA_TARGET_ROOT_DIR              ?= ${DIRECTFB_PREFIX}
INSIGNIA_TARGET_BIN_DIR               := ${INSIGNIA_TARGET_ROOT_DIR}/bin
INSIGNIA_TARGET_BIN_INS_DIR           := ${INSIGNIA_TARGET_BIN_DIR}/insignia
INSIGNIA_TARGET_BIN_INS_VER_DIR       := ${INSIGNIA_TARGET_BIN_INS_DIR}/${INSIGNIA_MAJOR}.${INSIGNIA_MINOR}
INSIGNIA_PUB_INS_DIR                  := ${DIRECTFB_PUB_DIR}/Insignia
INSIGNIA_PUB_INS_VER1_DIR             := ${INSIGNIA_PUB_INS_DIR}/${INSIGNIA_MAJOR}.${INSIGNIA_MINOR}
INSIGNIA_PUB_INS_VER2_DIR             := ${INSIGNIA_PUB_INS_VER1_DIR}.${INSIGNIA_MICRO}
INSIGNIA_PRI_INS_DIR                  := ${DIRECTFB_PRI_DIR}/Insignia
INSIGNIA_PRI_INS_VER1_DIR             := ${INSIGNIA_PRI_INS_DIR}/${INSIGNIA_MAJOR}.${INSIGNIA_MINOR}
INSIGNIA_PRI_INS_VER2_DIR             := ${INSIGNIA_PRI_INS_VER1_DIR}.${INSIGNIA_MICRO}
INSIGNIA_SRC_DIR                      := ${DIRECTFB_SRC_DIR}/Insignia-${INSIGNIA_VERSION}
INSIGNIA_INCLUDE_DIR                  := ${INSIGNIA_SRC_DIR}/include
INSIGNIA_INSTALL_DIR                  ?= ${DIRECTFB_INSTALL_DIR}
INSIGNIA_INSTALL_ROOT_DIR             := ${INSIGNIA_INSTALL_DIR}/${INSIGNIA_TARGET_ROOT_DIR}
INSIGNIA_INSTALL_BIN_DIR              := ${INSIGNIA_INSTALL_DIR}/${INSIGNIA_TARGET_BIN_DIR}
INSIGNIA_INSTALL_BIN_INS_DIR          := ${INSIGNIA_INSTALL_DIR}/${INSIGNIA_TARGET_BIN_INS_DIR}
INSIGNIA_INSTALL_BIN_INS_VER_DIR      := ${INSIGNIA_INSTALL_DIR}/${INSIGNIA_TARGET_BIN_INS_VER_DIR}
INSIGNIA_INSTALL_INCLUDE_DIR          := ${INSIGNIA_INSTALL_ROOT_DIR}/include
INSIGNIA_INSTALL_LIB_DIR              := ${INSIGNIA_INSTALL_ROOT_DIR}/lib
INSIGNIA_INSTALL_PKG_CONFIG_DIR       := ${INSIGNIA_INSTALL_LIB_DIR}/pkgconfig
INSIGNIA_CONFIG_FLAGS                 :=          \
    --prefix=${INSIGNIA_TARGET_ROOT_DIR}          \
    --bindir=${INSIGNIA_TARGET_BIN_INS_VER_DIR}   \
    --host=$(B_REFSW_TOOLCHAIN_ARCH)

INSIGNIA_BUILD_TARGET                 := insignia-all
INSIGNIA_CLEAN_TARGET                 := insignia-clean
INSIGNIA_DISTCLEAN_TARGET             := insignia-distclean
INSIGNIA_MRPROPER_TARGET              := insignia-mrproper
INSIGNIA_UNINSTALL_TARGET             := insignia-uninstall
INSIGNIA_UNPACKED_FLAG                := ${INSIGNIA_SRC_DIR}/.unpacked
INSIGNIA_CONFIGURATION_FLAG           := ${INSIGNIA_SRC_DIR}/.configuration
INSIGNIA_CONFIGURED_FLAG              := ${INSIGNIA_SRC_DIR}/.configured
INSIGNIA_COMPILED_FLAG                := ${INSIGNIA_SRC_DIR}/.compiled
INSIGNIA_INSTALLED_FLAG               := ${INSIGNIA_INSTALL_ROOT_DIR}/.insignia_installed
INSIGNIA_FLAG                         := ${INSIGNIA_INSTALL_ROOT_DIR}/.insignia
EXTRA_CLEAN_TARGETS                   += ${INSIGNIA_CLEAN_TARGET}
EXTRA_DISTCLEAN_TARGETS               += ${INSIGNIA_DISTCLEAN_TARGET}
EXTRA_MRPROPER_TARGETS                += ${INSIGNIA_MRPROPER_TARGET}
EXTRA_UNINSTALL_TARGETS               += ${INSIGNIA_UNINSTALL_TARGET}
ifeq ($(BUILD_INSIGNIA),y)
EXTRA_BUILD_TARGETS                   += ${INSIGNIA_BUILD_TARGET}
EXTRA_CONFIGURED_TARGETS              += ${INSIGNIA_CONFIGURED_FLAG}
EXTRA_COMPILED_TARGETS                += ${INSIGNIA_COMPILED_FLAG}
EXTRA_INSTALLED_TARGETS               += ${INSIGNIA_INSTALLED_FLAG}
EXTRA_TARGET_INSTALLED_TARGETS        += ${INSIGNIA_FLAG}
endif

#
# Tacho Specific Defines
#
TACHO_VERSION                      ?= 0.1.2
TACHO_MAJOR                        := $(shell echo ${TACHO_VERSION} | cut -d. -f1)
TACHO_MINOR                        := $(shell echo ${TACHO_VERSION} | cut -d. -f2)
TACHO_MICRO                        := $(shell echo ${TACHO_VERSION} | cut -d. -f3)
TACHO_SOURCE_TARBALL               := Tacho-${TACHO_VERSION}.tar.gz
TACHO_TARGET_ROOT_DIR              ?= ${DIRECTFB_PREFIX}
TACHO_TARGET_BIN_DIR               := ${TACHO_TARGET_ROOT_DIR}/bin
TACHO_TARGET_BIN_TAC_DIR           := ${TACHO_TARGET_BIN_DIR}/tacho
TACHO_TARGET_BIN_TAC_VER_DIR       := ${TACHO_TARGET_BIN_TAC_DIR}/${TACHO_MAJOR}.${TACHO_MINOR}
TACHO_PUB_TAC_DIR                  := ${DIRECTFB_PUB_DIR}/Tacho
TACHO_PUB_TAC_VER1_DIR             := ${TACHO_PUB_TAC_DIR}/${TACHO_MAJOR}.${TACHO_MINOR}
TACHO_PUB_TAC_VER2_DIR             := ${TACHO_PUB_TAC_VER1_DIR}.${TACHO_MICRO}
TACHO_PRI_TAC_DIR                  := ${DIRECTFB_PRI_DIR}/Tacho
TACHO_PRI_TAC_VER1_DIR             := ${TACHO_PRI_TAC_DIR}/${TACHO_MAJOR}.${TACHO_MINOR}
TACHO_PRI_TAC_VER2_DIR             := ${TACHO_PRI_TAC_VER1_DIR}.${TACHO_MICRO}
TACHO_SRC_DIR                      := ${DIRECTFB_SRC_DIR}/Tacho-${TACHO_VERSION}
TACHO_INCLUDE_DIR                  := ${TACHO_SRC_DIR}/include
TACHO_INSTALL_DIR                  ?= ${DIRECTFB_INSTALL_DIR}
TACHO_INSTALL_ROOT_DIR             := ${TACHO_INSTALL_DIR}/${TACHO_TARGET_ROOT_DIR}
TACHO_INSTALL_BIN_DIR              := ${TACHO_INSTALL_DIR}/${TACHO_TARGET_BIN_DIR}
TACHO_INSTALL_BIN_TAC_DIR          := ${TACHO_INSTALL_DIR}/${TACHO_TARGET_BIN_TAC_DIR}
TACHO_INSTALL_BIN_TAC_VER_DIR      := ${TACHO_INSTALL_DIR}/${TACHO_TARGET_BIN_TAC_VER_DIR}
TACHO_INSTALL_INCLUDE_DIR          := ${TACHO_INSTALL_ROOT_DIR}/include
TACHO_INSTALL_LIB_DIR              := ${TACHO_INSTALL_ROOT_DIR}/lib
TACHO_INSTALL_PKG_CONFIG_DIR       := ${TACHO_INSTALL_LIB_DIR}/pkgconfig
TACHO_CONFIG_FLAGS                 :=          \
    --prefix=${TACHO_TARGET_ROOT_DIR}          \
    --bindir=${TACHO_TARGET_BIN_TAC_VER_DIR}   \
    --host=$(B_REFSW_TOOLCHAIN_ARCH)

TACHO_BUILD_TARGET                 := tacho-all
TACHO_CLEAN_TARGET                 := tacho-clean
TACHO_DISTCLEAN_TARGET             := tacho-distclean
TACHO_MRPROPER_TARGET              := tacho-mrproper
TACHO_UNINSTALL_TARGET             := tacho-uninstall
TACHO_UNPACKED_FLAG                := ${TACHO_SRC_DIR}/.unpacked
TACHO_CONFIGURATION_FLAG           := ${TACHO_SRC_DIR}/.configuration
TACHO_CONFIGURED_FLAG              := ${TACHO_SRC_DIR}/.configured
TACHO_COMPILED_FLAG                := ${TACHO_SRC_DIR}/.compiled
TACHO_INSTALLED_FLAG               := ${TACHO_INSTALL_ROOT_DIR}/.tacho_installed
TACHO_FLAG                         := ${TACHO_INSTALL_ROOT_DIR}/.tacho
EXTRA_CLEAN_TARGETS                += ${TACHO_CLEAN_TARGET}
EXTRA_DISTCLEAN_TARGETS            += ${TACHO_DISTCLEAN_TARGET}
EXTRA_MRPROPER_TARGETS             += ${TACHO_MRPROPER_TARGET}
EXTRA_UNINSTALL_TARGETS            += ${TACHO_UNINSTALL_TARGET}
ifeq ($(BUILD_TACHO),y)
EXTRA_BUILD_TARGETS                += ${TACHO_BUILD_TARGET}
EXTRA_CONFIGURED_TARGETS           += ${TACHO_CONFIGURED_FLAG}
EXTRA_COMPILED_TARGETS             += ${TACHO_COMPILED_FLAG}
EXTRA_INSTALLED_TARGETS            += ${TACHO_INSTALLED_FLAG}
EXTRA_TARGET_INSTALLED_TARGETS     += ${TACHO_FLAG}
endif

##
#
# FreeType directory
#
DFB_FREETYPE_APPLIBS                := $(shell test "$(DIRECTFB_APPLIBS)" = "y" && test -d "$(OPENSOURCE_TOP)/freetype" && echo "y" || echo "n")
ifeq ($(DFB_FREETYPE_APPLIBS),y)
DFB_FREETYPE_VERSION                ?= 2.3.7
DFB_FREETYPE_TOP                    := $(OPENSOURCE_TOP)/freetype
else
DFB_FREETYPE_VERSION                ?= 2.1.5
DFB_FREETYPE_TOP                    := $(BSEAV)/lib
endif
DFB_FREETYPE_MAJOR                  := $(shell echo ${DFB_FREETYPE_VERSION} | cut -d. -f1)
DFB_FREETYPE_MINOR                  := $(shell echo ${DFB_FREETYPE_VERSION} | cut -d. -f2)
DFB_FREETYPE_MICRO                  := $(shell echo ${DFB_FREETYPE_VERSION} | cut -d. -f3)
DFB_FREETYPE_SRC_DIR                := ${DFB_FREETYPE_TOP}/freetype-${DFB_FREETYPE_VERSION}
DFB_FREETYPE_SOURCE_TARBALL         := ${DFB_FREETYPE_TOP}/freetype-${DFB_FREETYPE_VERSION}.tar.gz
DFB_FREETYPE_INSTALL_DIR            ?= ${DIRECTFB_OBJECT_DIR}
DFB_FREETYPE_INSTALL_INCLUDE_DIR    := ${DFB_FREETYPE_INSTALL_DIR}/include
DFB_FREETYPE_INSTALL_LIB_DIR        := ${DFB_FREETYPE_INSTALL_DIR}/lib
DFB_FREETYPE_INSTALL_PKG_CONFIG_DIR := ${DFB_FREETYPE_INSTALL_LIB_DIR}/pkgconfig
DFB_FREETYPE_PKG_CONFIG             := freetype2
DFB_FREETYPE_UNPACKED_FLAG          := ${DFB_FREETYPE_SRC_DIR}/.unpacked
DFB_FREETYPE_CONFIGURATION_FLAG     := ${DFB_FREETYPE_SRC_DIR}/.configuration
DFB_FREETYPE_CONFIGURED_FLAG        := ${DFB_FREETYPE_SRC_DIR}/.configured
DFB_FREETYPE_COMPILED_FLAG          := ${DFB_FREETYPE_SRC_DIR}/.compiled
DFB_FREETYPE_INSTALLED_FLAG         := ${DFB_FREETYPE_INSTALL_DIR}/.freetype_installed
DFB_FREETYPE_FLAG                   := ${DFB_FREETYPE_INSTALL_DIR}/.freetype
DFB_FREETYPE_CONFIG_FLAGS           := --host=${B_REFSW_TOOLCHAIN_ARCH} --prefix=${DFB_FREETYPE_INSTALL_DIR}
ifeq ($(DIRECTFB_SHARED),y)
DFB_FREETYPE_CONFIG_FLAGS           += --enable-shared
else
DFB_FREETYPE_CONFIG_FLAGS           += --disable-shared
endif

##
#
# JPEG directory
#
DFB_JPEG_APPLIBS                    := $(shell test "$(DIRECTFB_APPLIBS)" = "y" && test -d "$(OPENSOURCE_TOP)/jpeg" && echo "y" || echo "n")
ifeq ($(DFB_JPEG_APPLIBS),y)
DFB_JPEG_VERSION                    ?= 6b
DFB_JPEG_TOP                        := $(OPENSOURCE_TOP)/jpeg
else
DFB_JPEG_VERSION                    ?= 6b
DFB_JPEG_TOP                        := $(BSEAV)/lib
endif
DFB_JPEG_MAJOR                      := $(shell echo ${DFB_JPEG_VERSION} | cut -d. -f1)
DFB_JPEG_MINOR                      := $(shell echo ${DFB_JPEG_VERSION} | cut -d. -f2)
DFB_JPEG_MICRO                      := $(shell echo ${DFB_JPEG_VERSION} | cut -d. -f3)
DFB_JPEG_SRC_DIR                    := ${DFB_JPEG_TOP}/jpeg-${DFB_JPEG_VERSION}
DFB_JPEG_SOURCE_TARBALL             := ${DFB_JPEG_TOP}/jpeg-${DFB_JPEG_VERSION}.tar.gz
DFB_JPEG_INSTALL_DIR                ?= ${DIRECTFB_OBJECT_DIR}
DFB_JPEG_INSTALL_INCLUDE_DIR        := ${DFB_JPEG_INSTALL_DIR}/include
DFB_JPEG_INSTALL_LIB_DIR            := ${DFB_JPEG_INSTALL_DIR}/lib
DFB_JPEG_UNPACKED_FLAG              := ${DFB_JPEG_SRC_DIR}/.unpacked
DFB_JPEG_CONFIGURATION_FLAG         := ${DFB_JPEG_SRC_DIR}/.configuration
DFB_JPEG_CONFIGURED_FLAG            := ${DFB_JPEG_SRC_DIR}/.configured
DFB_JPEG_COMPILED_FLAG              := ${DFB_JPEG_SRC_DIR}/.compiled
DFB_JPEG_INSTALLED_FLAG             := ${DFB_JPEG_INSTALL_DIR}/.jpeg_installed
DFB_JPEG_FLAG                       := ${DFB_JPEG_INSTALL_DIR}/.jpeg
DFB_JPEG_CONFIG_FLAGS               := --host=$(B_REFSW_TOOLCHAIN_ARCH) --prefix=${DFB_JPEG_INSTALL_DIR}
ifeq ($(DIRECTFB_SHARED),y)
DFB_JPEG_CONFIG_FLAGS               += --enable-shared
else
DFB_JPEG_CONFIG_FLAGS               += --disable-shared
endif

##
#
# PNG directory
#
DFB_PNG_APPLIBS                     := $(shell test "$(DIRECTFB_APPLIBS)" = "y" && test -d "$(OPENSOURCE_TOP)/libpng" && echo "y" || echo "n")
DFB_PNG_INSTALL_DIR                 ?= ${DIRECTFB_OBJECT_DIR}
ifeq ($(DFB_PNG_APPLIBS),y)
DFB_PNG_VERSION                     ?= 1.2.29
DFB_PNG_TOP                         := $(OPENSOURCE_TOP)/libpng
DFB_PNG_SRC_DIR                     := ${DFB_PNG_TOP}/libpng-${DFB_PNG_VERSION}
else
DFB_PNG_VERSION                     ?= 1.2.8
DFB_PNG_TOP                         := $(BSEAV)/lib
DFB_PNG_SRC_DIR                     := ${DFB_PNG_TOP}/libpng
DFB_PNG_INSTALL_OPTIONS             := prefix=${DFB_PNG_INSTALL_DIR}
endif
DFB_PNG_MAJOR                       := $(shell echo ${DFB_PNG_VERSION} | cut -d. -f1)
DFB_PNG_MINOR                       := $(shell echo ${DFB_PNG_VERSION} | cut -d. -f2)
DFB_PNG_MICRO                       := $(shell echo ${DFB_PNG_VERSION} | cut -d. -f3)
DFB_PNG_SOURCE_TARBALL              := ${DFB_PNG_TOP}/libpng-${DFB_PNG_VERSION}.tar.gz
DFB_PNG_INSTALL_INCLUDE_DIR         := ${DFB_PNG_INSTALL_DIR}/include
DFB_PNG_INSTALL_LIB_DIR             := ${DFB_PNG_INSTALL_DIR}/lib
DFB_PNG_INSTALL_PKG_CONFIG_DIR      := ${DFB_PNG_INSTALL_LIB_DIR}/pkgconfig
DFB_PNG_PKG_CONFIG                  := libpng12
DFB_PNG_UNPACKED_FLAG               := ${DFB_PNG_SRC_DIR}/.unpacked
DFB_PNG_CONFIGURATION_FLAG          := ${DFB_PNG_SRC_DIR}/.configuration
DFB_PNG_CONFIGURED_FLAG             := ${DFB_PNG_SRC_DIR}/.configured
DFB_PNG_COMPILED_FLAG               := ${DFB_PNG_SRC_DIR}/.compiled
DFB_PNG_INSTALLED_FLAG              := ${DFB_PNG_INSTALL_DIR}/.png_installed
DFB_PNG_FLAG                        := ${DFB_PNG_INSTALL_DIR}/.png
DFB_PNG_CONFIG_FLAGS                := --host=$(B_REFSW_TOOLCHAIN_ARCH) --prefix=${DFB_PNG_INSTALL_DIR}
ifeq ($(DIRECTFB_SHARED),y)
DFB_PNG_CONFIG_FLAGS                += --enable-shared
else
DFB_PNG_CONFIG_FLAGS                += --disable-shared
endif

##
#
# ZLIB directory
#
DFB_ZLIB_APPLIBS                    := $(shell test "$(DIRECTFB_APPLIBS)" = "y" && test -d "$(OPENSOURCE_TOP)/zlib" && echo "y" || echo "n")
ifeq ($(DFB_ZLIB_APPLIBS),y)
DFB_ZLIB_VERSION                    ?= 1.2.3
DFB_ZLIB_TOP                        := $(OPENSOURCE_TOP)/zlib
DFB_ZLIB_SRC_DIR                    := ${DFB_ZLIB_TOP}/zlib-${DFB_ZLIB_VERSION}
else
DFB_ZLIB_VERSION                    ?= 1.1.3
DFB_ZLIB_TOP                        := $(BSEAV)/lib
DFB_ZLIB_SRC_DIR                    := ${DFB_ZLIB_TOP}/zlib
ifeq ($(DIRECTFB_SHARED),y)
DFB_ZLIB_CONFIG_OPTIONS             := LDSHARED="${CC} -shared -Wl,-soname,libz.so.1"
endif
endif
DFB_ZLIB_MAJOR                      := $(shell echo ${DFB_ZLIB_VERSION} | cut -d. -f1)
DFB_ZLIB_MINOR                      := $(shell echo ${DFB_ZLIB_VERSION} | cut -d. -f2)
DFB_ZLIB_MICRO                      := $(shell echo ${DFB_ZLIB_VERSION} | cut -d. -f3)
DFB_ZLIB_SOURCE_TARBALL             := ${DFB_ZLIB_TOP}/zlib-${DFB_ZLIB_VERSION}.tar.gz
DFB_ZLIB_INSTALL_DIR                ?= ${DIRECTFB_OBJECT_DIR}
DFB_ZLIB_INSTALL_INCLUDE_DIR        := ${DFB_ZLIB_INSTALL_DIR}/include
DFB_ZLIB_INSTALL_LIB_DIR            := ${DFB_ZLIB_INSTALL_DIR}/lib
DFB_ZLIB_UNPACKED_FLAG              := ${DFB_ZLIB_SRC_DIR}/.unpacked
DFB_ZLIB_CONFIGURATION_FLAG         := ${DFB_ZLIB_SRC_DIR}/.configuration
DFB_ZLIB_CONFIGURED_FLAG            := ${DFB_ZLIB_SRC_DIR}/.configured
DFB_ZLIB_COMPILED_FLAG              := ${DFB_ZLIB_SRC_DIR}/.compiled
DFB_ZLIB_INSTALLED_FLAG             := ${DFB_ZLIB_INSTALL_DIR}/.zlib_installed
DFB_ZLIB_FLAG                       := ${DFB_ZLIB_INSTALL_DIR}/.zlib
DFB_ZLIB_CONFIG_FLAGS               := --prefix=${DFB_ZLIB_INSTALL_DIR}
ifeq ($(DIRECTFB_SHARED),y)
DFB_ZLIB_CONFIG_FLAGS               += --shared
endif

##
#
# Specify Nexus Flag
#
NEXUS_FLAG                          := ${DIRECTFB_OBJECT_DIR}/.nexus

##
#
# Specify only the open source files that need to be released
#
DIRECTFB_LIMITED_PATH := ${DIRECTFB_BUILD_DIR}/Makefile ${DIRECTFB_BUILD_DIR}/directfb_common.inc ${DIRECTFB_BUILD_DIR}/Rules.make
DIRECTFB_LIMITED_PATH += ${DIRECTFB_DOCS_DIR} ${DIRECTFB_SRC_DFB_TAR_DIR} ${DIRECTFB_PUB_DIR}
DIRECTFB_LIMITED_PATH += $(wildcard ${DIRECTFB_BUILD_DIR}/${DIRECTFB_MAJOR}.*)

ifeq ($(DFB_FREETYPE_APPLIBS),y)
DIRECTFB_LIMITED_PATH += ${DFB_FREETYPE_SOURCE_TARBALL}
else
DIRECTFB_LIMITED_PATH += ${DFB_FREETYPE_SRC_DIR}
endif

ifeq ($(DFB_JPEG_APPLIBS),y)
DIRECTFB_LIMITED_PATH += ${DFB_JPEG_SOURCE_TARBALL}
else
DIRECTFB_LIMITED_PATH += ${DFB_JPEG_SRC_DIR}
endif

ifeq ($(DFB_PNG_APPLIBS),y)
DIRECTFB_LIMITED_PATH += ${DFB_PNG_SOURCE_TARBALL}
else
DIRECTFB_LIMITED_PATH += ${DFB_PNG_SRC_DIR}
endif

ifeq ($(DFB_ZLIB_APPLIBS),y)
DIRECTFB_LIMITED_PATH += ${DFB_ZLIB_SOURCE_TARBALL}
else
DIRECTFB_LIMITED_PATH += ${DFB_ZLIB_SRC_DIR}
endif

DIRECTFB_LIMITED_LIST := $(shell echo ${DIRECTFB_LIMITED_PATH} ${DIRECTFB_PRE_DIR} | sed -e "s;/[^ ]*AppLibs/;AppLibs/;g;s;/[^ ]*BSEAV/;BSEAV/;g")

##
#
# Specify the open source and Broadcom SLA files that need to be released
#
DIRECTFB_RELEASE_PATH := ${DIRECTFB_LIMITED_PATH} ${DIRECTFB_PRI_DIR}
DIRECTFB_RELEASE_LIST := $(shell echo ${DIRECTFB_RELEASE_PATH} | sed -e "s;/[^ ]*AppLibs/;AppLibs/;g;s;/[^ ]*BSEAV/;BSEAV/;g")

