/***************************************************************************
 *     (c)2007-2010 Broadcom Corporation
 *
 *  This program is the proprietary software of Broadcom Corporation and/or its licensors,
 *  and may only be used, duplicated, modified or distributed pursuant to the terms and
 *  conditions of a separate, written license agreement executed between you and Broadcom
 *  (an "Authorized License").  Except as set forth in an Authorized License, Broadcom grants
 *  no license (express or implied), right to use, or waiver of any kind with respect to the
 *  Software, and Broadcom expressly reserves all rights in and to the Software and all
 *  intellectual property rights therein.  IF YOU HAVE NO AUTHORIZED LICENSE, THEN YOU
 *  HAVE NO RIGHT TO USE THIS SOFTWARE IN ANY WAY, AND SHOULD IMMEDIATELY
 *  NOTIFY BROADCOM AND DISCONTINUE ALL USE OF THE SOFTWARE.
 *
 *  Except as expressly set forth in the Authorized License,
 *
 *  1.     This program, including its structure, sequence and organization, constitutes the valuable trade
 *  secrets of Broadcom, and you shall use all reasonable efforts to protect the confidentiality thereof,
 *  and to use this information only in connection with your use of Broadcom integrated circuit products.
 *
 *  2.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, THE SOFTWARE IS PROVIDED "AS IS"
 *  AND WITH ALL FAULTS AND BROADCOM MAKES NO PROMISES, REPRESENTATIONS OR
 *  WARRANTIES, EITHER EXPRESS, IMPLIED, STATUTORY, OR OTHERWISE, WITH RESPECT TO
 *  THE SOFTWARE.  BROADCOM SPECIFICALLY DISCLAIMS ANY AND ALL IMPLIED WARRANTIES
 *  OF TITLE, MERCHANTABILITY, NONINFRINGEMENT, FITNESS FOR A PARTICULAR PURPOSE,
 *  LACK OF VIRUSES, ACCURACY OR COMPLETENESS, QUIET ENJOYMENT, QUIET POSSESSION
 *  OR CORRESPONDENCE TO DESCRIPTION. YOU ASSUME THE ENTIRE RISK ARISING OUT OF
 *  USE OR PERFORMANCE OF THE SOFTWARE.
 *
 *  3.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, IN NO EVENT SHALL BROADCOM OR ITS
 *  LICENSORS BE LIABLE FOR (i) CONSEQUENTIAL, INCIDENTAL, SPECIAL, INDIRECT, OR
 *  EXEMPLARY DAMAGES WHATSOEVER ARISING OUT OF OR IN ANY WAY RELATING TO YOUR
 *  USE OF OR INABILITY TO USE THE SOFTWARE EVEN IF BROADCOM HAS BEEN ADVISED OF
 *  THE POSSIBILITY OF SUCH DAMAGES; OR (ii) ANY AMOUNT IN EXCESS OF THE AMOUNT
 *  ACTUALLY PAID FOR THE SOFTWARE ITSELF OR U.S. $1, WHICHEVER IS GREATER. THESE
 *  LIMITATIONS SHALL APPLY NOTWITHSTANDING ANY FAILURE OF ESSENTIAL PURPOSE OF
 *  ANY LIMITED REMEDY.
 *
 * $brcm_Workfile: bcmnexus_bt_keycodes_generic.h $
 * $brcm_Revision: DirectFB_1_4_Port/DirectFB_1_4_1/1 $
 *
 * [File Description:]
 *
 * Revision History:
 *
 * $brcm_Log: /AppLibs/opensource/directfb/src/broadcom_files/private/DirectFB/1.4.1/inputdrivers/bcmnexus/bcmnexus_bt_keycodes_generic.h $
 * 
 * DirectFB_1_4_Port/DirectFB_1_4_1/1   12/13/10 7:55p scchang
 * SW7420-1313: Add bluetooth handset support
 * 
 ***************************************************************************/
#ifndef __bcmnexus_bt_keycodes_generic_H__
#define __bcmnexus_bt_keycodes_generic_H__

/*
** Consumer Page key code maps.
**
** The "hwEventCode"s  in the following table are the values mapped in Consumer Page (0x0C).
**
** The "DIKS_xxx" constants are for the basic keyboard mapping (defined in "Directfb_keyboard.h").
** The "DIKI_xxx" constants are for the advanced keyboard mapping.
*/

KeyMapElement csmrBasicCodeMap [] =
{
    { DIKI_0,       0x000a },  /* should these be the DIKI_KP_xxx constants? */
    { DIKI_1,       0x0001 },
    { DIKI_2,       0x0002 },
    { DIKI_3,       0x0003 },
    { DIKI_4,       0x0004 },
    { DIKI_5,       0x0005 },
    { DIKI_6,       0x0006 },
    { DIKI_7,       0x0007 },
    { DIKI_8,       0x0008 },
    { DIKI_9,       0x0009 },
    { DIKI_LEFT,    0x0044 },
    { DIKI_RIGHT,   0x0045 },
    { DIKI_DOWN,    0x0043 },
    { DIKI_UP,      0x0042 },
    { DIKI_ENTER,   0x0041 },  /* the select key on the remote */
    { DIKI_ESCAPE,  0x0046 }   /* the exit key on the remote */
};

KeyMapElement csmrAdvanCodeMap [] =
{
    { DIKS_0,               0x000a },
    { DIKS_1,               0x0001 },
    { DIKS_2,               0x0002 },
    { DIKS_3,               0x0003 },
    { DIKS_4,               0x0004 },
    { DIKS_5,               0x0005 },
    { DIKS_6,               0x0006 },
    { DIKS_7,               0x0007 },
    { DIKS_8,               0x0008 },
    { DIKS_9,               0x0009 },
    { DIKS_CURSOR_LEFT,     0x0044 },
    { DIKS_CURSOR_RIGHT,    0x0045 },
    { DIKS_CURSOR_DOWN,     0x0043 },
    { DIKS_CURSOR_UP,       0x0042 },
    { DIKS_CHANNEL_UP,      0x009c },
    { DIKS_CHANNEL_DOWN,    0x009d },
    { DIKS_SELECT,          0x0041 },
    { DIKS_EXIT,            0x0046 },
    { DIKS_MENU,            0x0040 },
    { DIKS_PROGRAM,         0x008d },
    { DIKS_POWER,           0x0030 },
    { DIKS_INFO,            0x0209 },
    { DIKS_MUTE,            0x00e2 },
    { DIKS_PREVIOUS,        0x0083 },
    { DIKS_REWIND,          0x00b4 },
    { DIKS_PLAY,            0x00b0 },
    { DIKS_FORWARD,         0x00b3 }, /* 0x00ca; we remap FastForward to Forward for CES2010 */
/*  { DIKS_RECORD,          0x00b2 }, //we disable Record for CES2010 */
    { DIKS_PAUSE,           0x00b1 },
    { DIKS_FAST,            0x00f4 },
    { DIKS_STOP,            0x00b7 },
/*  { DIKS_FASTFORWARD,     0x00b3 }, // we disable FastForward for CES2010 */
    { DIKS_MODE,            0x0082 },
    { DIKS_FAVORITES,       0x022a }, /* FAV */
    { DIKS_VOLUME_UP,       0x00e9 },
    { DIKS_VOLUME_DOWN,     0x00ea },
    { DIKS_CUSTOM0,         0x805d }, /* A - Vizio Yellow */
    { DIKS_CUSTOM1,         0x805e }, /* B - Vizio Blue */
    { DIKS_CUSTOM2,         0x805b }, /* C - Vizio Red */
    { DIKS_CUSTOM3,         0x805c }, /* D - Vizio Green */
};

/*
** Keypad key code maps.
**
** The arry index is the value of mapping code in Keyboard/Keypad Page (0x07).
**
** The  "kbdxxxMap" tables are for the key mapping without Shift/Caps modifier.
** The  "kbdxxxAltMap" tables are for the key mapping with Shift/Caps modifier on.
** The  "DIKI_xxx" constants are for the "key_id"  mapping.
** The  "DIKS_xxx" constants are for the "key_symbol" mapping (defined in "Directfb_keyboard.h").
**
*/
static const
DFBInputDeviceKeyIdentifier kbdBasicCodeMap[] = {
    DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_A, DIKI_B, DIKI_C, DIKI_D,
    DIKI_E, DIKI_F, DIKI_G, DIKI_H, DIKI_I, DIKI_J, DIKI_K, DIKI_L,
    DIKI_M, DIKI_N, DIKI_O, DIKI_P, DIKI_Q, DIKI_R, DIKI_S, DIKI_T,
    DIKI_U, DIKI_V, DIKI_W, DIKI_X, DIKI_Y, DIKI_Z, DIKI_1, DIKI_2,
    DIKI_3, DIKI_4, DIKI_5, DIKI_6, DIKI_7, DIKI_8, DIKI_9, DIKI_0,
    DIKI_ENTER, DIKI_ESCAPE, DIKI_BACKSPACE, DIKI_TAB, DIKI_SPACE, DIKI_MINUS_SIGN, DIKI_EQUALS_SIGN, DIKI_BRACKET_LEFT,
    DIKI_BRACKET_RIGHT, DIKI_BACKSLASH, DIKI_UNKNOWN, DIKI_SEMICOLON, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_COMMA, DIKI_PERIOD,
    DIKI_SLASH, DIKI_CAPS_LOCK, DIKI_F1, DIKI_F2, DIKI_F3, DIKI_F4, DIKI_F5, DIKI_F6,
    DIKI_F7, DIKI_F8, DIKI_F9, DIKI_F10, DIKI_F11, DIKI_F12, DIKI_UNKNOWN, DIKI_SCROLL_LOCK,
    DIKI_PAUSE, DIKI_INSERT, DIKI_HOME, DIKI_PAGE_UP, DIKI_DELETE, DIKI_END, DIKI_PAGE_DOWN, DIKI_RIGHT,
    DIKI_LEFT, DIKI_DOWN, DIKI_UP, DIKI_NUM_LOCK, DIKI_SLASH, DIKI_UNKNOWN, DIKI_MINUS_SIGN, DIKI_UNKNOWN,
    DIKI_ENTER, DIKI_1, DIKI_2, DIKI_3, DIKI_4, DIKI_5, DIKI_6, DIKI_7,
    DIKI_8, DIKI_9, DIKI_0, DIKI_PERIOD, DIKI_BACKSLASH, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_EQUALS_SIGN, 
    DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN,
    DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_ENTER,
    DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN,
    DIKI_UNKNOWN, DIKI_UNKNOWN
};

static const
DFBInputDeviceKeyIdentifier kbdBasicCodeAltMap[] = {
    DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_A, DIKI_B, DIKI_C, DIKI_D,
    DIKI_E, DIKI_F, DIKI_G, DIKI_H, DIKI_I, DIKI_J, DIKI_K, DIKI_L,
    DIKI_M, DIKI_N, DIKI_O, DIKI_P, DIKI_Q, DIKI_R, DIKI_S, DIKI_T,
    DIKI_U, DIKI_V, DIKI_W, DIKI_X, DIKI_Y, DIKI_Z, DIKI_UNKNOWN, DIKI_UNKNOWN,
    DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_BRACKET_LEFT, DIKI_BRACKET_RIGHT,
    DIKI_ENTER, DIKI_ESCAPE, DIKI_BACKSPACE, DIKI_TAB, DIKI_SPACE, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_BRACKET_LEFT,
    DIKI_BRACKET_RIGHT, DIKI_UNKNOWN, DIKI_QUOTE_LEFT, DIKI_UNKNOWN, DIKI_QUOTE_RIGHT, DIKI_QUOTE_LEFT, DIKI_LESS_SIGN, DIKI_UNKNOWN,
    DIKI_UNKNOWN, DIKI_CAPS_LOCK, DIKI_F1, DIKI_F2, DIKI_F3, DIKI_F4, DIKI_F5, DIKI_F6,
    DIKI_F7, DIKI_F8, DIKI_F9, DIKI_F10, DIKI_F11, DIKI_F12, DIKI_UNKNOWN, DIKI_SCROLL_LOCK,
    DIKI_PAUSE, DIKI_INSERT, DIKI_HOME, DIKI_PAGE_UP, DIKI_DELETE, DIKI_END, DIKI_PAGE_DOWN, DIKI_RIGHT,
    DIKI_LEFT, DIKI_DOWN, DIKI_UP, DIKI_NUM_LOCK, DIKI_SLASH, DIKI_UNKNOWN, DIKI_MINUS_SIGN, DIKI_UNKNOWN,
    DIKI_ENTER, DIKI_END, DIKI_DOWN, DIKI_PAGE_DOWN, DIKI_LEFT, DIKI_5, DIKI_RIGHT, DIKI_HOME,
    DIKI_UP, DIKI_PAGE_UP, DIKI_INSERT, DIKI_DELETE, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_EQUALS_SIGN,
    DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN,
    DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_ENTER,
    DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN, DIKI_UNKNOWN,
    DIKI_UNKNOWN, DIKI_UNKNOWN
};

static const
DFBInputDeviceKeySymbol kbdAdvanCodeMap[] = {
    DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_SMALL_A, DIKS_SMALL_B, DIKS_SMALL_C, DIKS_SMALL_D,
    DIKS_SMALL_E, DIKS_SMALL_F, DIKS_SMALL_G, DIKS_SMALL_H, DIKS_SMALL_I, DIKS_SMALL_J, DIKS_SMALL_K, DIKS_SMALL_L,
    DIKS_SMALL_M, DIKS_SMALL_N, DIKS_SMALL_O, DIKS_SMALL_P, DIKS_SMALL_Q, DIKS_SMALL_R, DIKS_SMALL_S, DIKS_SMALL_T,
    DIKS_SMALL_U, DIKS_SMALL_V, DIKS_SMALL_W, DIKS_SMALL_X, DIKS_SMALL_Y, DIKS_SMALL_Z, DIKS_1, DIKS_2,
    DIKS_3, DIKS_4, DIKS_5, DIKS_6, DIKS_7, DIKS_8, DIKS_9, DIKS_0,
    DIKS_RETURN, DIKS_ESCAPE, DIKS_BACKSPACE, DIKS_TAB, DIKS_SPACE, DIKS_MINUS_SIGN, DIKS_EQUALS_SIGN, DIKS_SQUARE_BRACKET_LEFT,
    DIKS_SQUARE_BRACKET_RIGHT, DIKS_BACKSLASH, DIKS_GRAVE_ACCENT, DIKS_SEMICOLON, DIKS_APOSTROPHE, DIKS_GRAVE_ACCENT, DIKS_COMMA, DIKS_PERIOD,
    DIKS_SLASH, DIKS_CAPS_LOCK, DIKS_F1, DIKS_F2, DIKS_F3, DIKS_F4, DIKS_F5, DIKS_F6,
    DIKS_F7, DIKS_F8, DIKS_F9, DIKS_F10, DIKS_F11, DIKS_F12, DIKS_CUSTOM3, DIKS_SCROLL_LOCK,
    DIKS_PAUSE, DIKS_INSERT, DIKS_HOME, DIKS_PAGE_UP, DIKS_DELETE, DIKS_END, DIKS_PAGE_DOWN, DIKS_CURSOR_RIGHT,
    DIKS_CURSOR_LEFT, DIKS_CURSOR_DOWN, DIKS_CURSOR_UP, DIKS_NUM_LOCK, DIKS_SLASH, DIKS_ASTERISK, DIKS_MINUS_SIGN, DIKS_PLUS_SIGN,
    DIKS_ENTER, DIKS_1, DIKS_2, DIKS_3, DIKS_4, DIKS_5, DIKS_6, DIKS_7,
    DIKS_8, DIKS_9, DIKS_0, DIKS_PERIOD, DIKS_BACKSLASH, DIKS_PROGRAM, DIKS_POWER, DIKS_EQUALS_SIGN, 
    DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_NULL,
    DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_GOTO, DIKS_HELP, DIKS_MENU, DIKS_SELECT,
    DIKS_STOP, DIKS_RESTART, DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_MUTE,
    DIKS_VOLUME_UP, DIKS_VOLUME_DOWN
};

static const
DFBInputDeviceKeySymbol kbdAdvanCodeAltMap[] = {
    DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_CAPITAL_A, DIKS_CAPITAL_B, DIKS_CAPITAL_C, DIKS_CAPITAL_D,
    DIKS_CAPITAL_E, DIKS_CAPITAL_F, DIKS_CAPITAL_G, DIKS_CAPITAL_H, DIKS_CAPITAL_I, DIKS_CAPITAL_J, DIKS_CAPITAL_K, DIKS_CAPITAL_L,
    DIKS_CAPITAL_M, DIKS_CAPITAL_N, DIKS_CAPITAL_O, DIKS_CAPITAL_P, DIKS_CAPITAL_Q, DIKS_CAPITAL_R, DIKS_CAPITAL_S, DIKS_CAPITAL_T,
    DIKS_CAPITAL_U, DIKS_CAPITAL_V, DIKS_CAPITAL_W, DIKS_CAPITAL_X, DIKS_CAPITAL_Y, DIKS_CAPITAL_Z, DIKS_EXCLAMATION_MARK, DIKS_AT,
    DIKS_NUMBER_SIGN, DIKS_DOLLAR_SIGN, DIKS_PERCENT_SIGN, DIKS_CIRCUMFLEX_ACCENT, DIKS_AMPERSAND, DIKS_ASTERISK, DIKS_PARENTHESIS_LEFT, DIKS_PARENTHESIS_RIGHT,
    DIKS_RETURN, DIKS_ESCAPE, DIKS_BACKSPACE, DIKS_TAB, DIKS_SPACE, DIKS_UNDERSCORE, DIKS_PLUS_SIGN, DIKS_CURLY_BRACKET_LEFT,
    DIKS_CURLY_BRACKET_RIGHT, DIKS_VERTICAL_BAR, DIKS_TILDE, DIKS_COLON, DIKS_QUOTATION, DIKS_TILDE, DIKS_LESS_THAN_SIGN, DIKS_GREATER_THAN_SIGN,
    DIKS_QUESTION_MARK, DIKS_CAPS_LOCK, DIKS_F1, DIKS_F2, DIKS_F3, DIKS_F4, DIKS_F5, DIKS_F6,
    DIKS_F7, DIKS_F8, DIKS_F9, DIKS_F10, DIKS_F11, DIKS_F12, DIKS_CUSTOM3, DIKS_SCROLL_LOCK,
    DIKS_PAUSE, DIKS_INSERT, DIKS_HOME, DIKS_PAGE_UP, DIKS_DELETE, DIKS_END, DIKS_PAGE_DOWN, DIKS_CURSOR_RIGHT,
    DIKS_CURSOR_LEFT, DIKS_CURSOR_DOWN, DIKS_CURSOR_UP, DIKS_NUM_LOCK, DIKS_SLASH, DIKS_ASTERISK, DIKS_MINUS_SIGN, DIKS_PLUS_SIGN,
    DIKS_ENTER, DIKS_END, DIKS_CURSOR_DOWN, DIKS_PAGE_DOWN, DIKS_CURSOR_LEFT, DIKS_5, DIKS_CURSOR_RIGHT, DIKS_HOME,
    DIKS_CURSOR_UP, DIKS_PAGE_UP, DIKS_INSERT, DIKS_DELETE, DIKS_VERTICAL_BAR, DIKS_PROGRAM, DIKS_POWER, DIKS_EQUALS_SIGN, 
    DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_NULL,
    DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_GOTO, DIKS_HELP, DIKS_MENU, DIKS_SELECT,
    DIKS_STOP, DIKS_RESTART, DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_NULL, DIKS_MUTE,
    DIKS_VOLUME_UP, DIKS_VOLUME_DOWN
};

#endif
