/******************************************************************************
 *    (c)2008-2009 Broadcom Corporation
 * 
 * This program is the proprietary software of Broadcom Corporation and/or its licensors,
 * and may only be used, duplicated, modified or distributed pursuant to the terms and
 * conditions of a separate, written license agreement executed between you and Broadcom
 * (an "Authorized License").  Except as set forth in an Authorized License, Broadcom grants
 * no license (express or implied), right to use, or waiver of any kind with respect to the
 * Software, and Broadcom expressly reserves all rights in and to the Software and all
 * intellectual property rights therein.  IF YOU HAVE NO AUTHORIZED LICENSE, THEN YOU
 * HAVE NO RIGHT TO USE THIS SOFTWARE IN ANY WAY, AND SHOULD IMMEDIATELY
 * NOTIFY BROADCOM AND DISCONTINUE ALL USE OF THE SOFTWARE.  
 *  
 * Except as expressly set forth in the Authorized License,
 *  
 * 1.     This program, including its structure, sequence and organization, constitutes the valuable trade
 * secrets of Broadcom, and you shall use all reasonable efforts to protect the confidentiality thereof,
 * and to use this information only in connection with your use of Broadcom integrated circuit products.
 *  
 * 2.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, THE SOFTWARE IS PROVIDED "AS IS" 
 * AND WITH ALL FAULTS AND BROADCOM MAKES NO PROMISES, REPRESENTATIONS OR 
 * WARRANTIES, EITHER EXPRESS, IMPLIED, STATUTORY, OR OTHERWISE, WITH RESPECT TO 
 * THE SOFTWARE.  BROADCOM SPECIFICALLY DISCLAIMS ANY AND ALL IMPLIED WARRANTIES 
 * OF TITLE, MERCHANTABILITY, NONINFRINGEMENT, FITNESS FOR A PARTICULAR PURPOSE, 
 * LACK OF VIRUSES, ACCURACY OR COMPLETENESS, QUIET ENJOYMENT, QUIET POSSESSION 
 * OR CORRESPONDENCE TO DESCRIPTION. YOU ASSUME THE ENTIRE RISK ARISING OUT OF 
 * USE OR PERFORMANCE OF THE SOFTWARE.
 * 
 * 3.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, IN NO EVENT SHALL BROADCOM OR ITS 
 * LICENSORS BE LIABLE FOR (i) CONSEQUENTIAL, INCIDENTAL, SPECIAL, INDIRECT, OR 
 * EXEMPLARY DAMAGES WHATSOEVER ARISING OUT OF OR IN ANY WAY RELATING TO YOUR 
 * USE OF OR INABILITY TO USE THE SOFTWARE EVEN IF BROADCOM HAS BEEN ADVISED OF 
 * THE POSSIBILITY OF SUCH DAMAGES; OR (ii) ANY AMOUNT IN EXCESS OF THE AMOUNT 
 * ACTUALLY PAID FOR THE SOFTWARE ITSELF OR U.S. $1, WHICHEVER IS GREATER. THESE 
 * LIMITATIONS SHALL APPLY NOTWITHSTANDING ANY FAILURE OF ESSENTIAL PURPOSE OF 
 * ANY LIMITED REMEDY.
 *
 * $brcm_Workfile: platform_join.c $
 * $brcm_Revision: DirectFB_1_4_Port/1 $
 * $brcm_Date: 7/8/09 3:19p $
 * 
 * Module Description:
 * 
 * Revision History:
 * 
 * $brcm_Log: /AppLibs/DirectFB/src/broadcom_files/DirectFB/1.4/platform_join.c $
 * 
 * DirectFB_1_4_Port/1   7/8/09 3:19p mphillip
 * PR56658: Add DirectFB 1.4.1 broadcom_files
 * 
 * 10   11/21/08 8:06p vsilyaev
 * PR 49524: Added graphics2d_sync routine that could be used by different
 *  users of Nexus_Graphics2D
 * 
 * 9   11/6/08 9:59a gmohile
 * PR 45243 : Turn off pre-alloc memory for graphics
 * 
 * 8   11/5/08 10:26a gmohile
 * PR 45243 : disable destructor
 * 
 * 7   11/3/08 1:57p gmohile
 * PR 45243 : Default all DTV to panel output
 * 
 * 6   10/24/08 12:42p gmohile
 * PR 46490 : Add hw picture decode support
 * 
 * 5   10/14/08 3:53p gmohile
 * PR 45243 : Fix nexus handles
 * 
 * 4   9/22/08 11:55a gmohile
 * PR 45243 : Fix 3548 display open
 * 
 * 3   9/15/08 11:49a gmohile
 * PR 46734 : Add dual output support
 * 
 * 2   9/9/08 1:47p gmohile
 * PR 45243 : Do not add outputs in platform init
 * 
 * 1   8/29/08 2:35p gmohile
 * PR 45243 : Do nexus platform init and display open outside directfb
 * 
 *****************************************************************************/
#include "bstd.h"
#include "platform_init.h"

#include <unistd.h>
#include <stdlib.h>
#include <string.h>

BDBG_MODULE(platform_join);
#define BDBG_MSG_TRACE(x)   BDBG_MSG(x)

//void (*nexus_graphics2d_sync)(void) = 0;

void platform_join(void) __attribute__ ((constructor));

void platform_join(void)
{
     NEXUS_Error rc;

     rc = NEXUS_Platform_Join(); 
     if(rc!=NEXUS_SUCCESS) {rc=BERR_TRACE(rc);goto err_platform;}
     BDBG_MSG_TRACE((">>platform_init"));

     return;

err_platform:
    _exit(1);
    /* not reached */
    return; 
}

void platform_uninit(void)
{
     BDBG_MSG_TRACE((">>platform_uninit"));
     BDBG_MSG_TRACE(("<<platform_uninit"));

     NEXUS_Platform_Uninit();
}

