/******************************************************************************
 *    (c)2010 Broadcom Corporation
 * 
 * This program is the proprietary software of Broadcom Corporation and/or its licensors,
 * and may only be used, duplicated, modified or distributed pursuant to the terms and
 * conditions of a separate, written license agreement executed between you and Broadcom
 * (an "Authorized License").  Except as set forth in an Authorized License, Broadcom grants
 * no license (express or implied), right to use, or waiver of any kind with respect to the
 * Software, and Broadcom expressly reserves all rights in and to the Software and all
 * intellectual property rights therein.  IF YOU HAVE NO AUTHORIZED LICENSE, THEN YOU
 * HAVE NO RIGHT TO USE THIS SOFTWARE IN ANY WAY, AND SHOULD IMMEDIATELY
 * NOTIFY BROADCOM AND DISCONTINUE ALL USE OF THE SOFTWARE.  
 *  
 * Except as expressly set forth in the Authorized License,
 *  
 * 1.     This program, including its structure, sequence and organization, constitutes the valuable trade
 * secrets of Broadcom, and you shall use all reasonable efforts to protect the confidentiality thereof,
 * and to use this information only in connection with your use of Broadcom integrated circuit products.
 *  
 * 2.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, THE SOFTWARE IS PROVIDED "AS IS" 
 * AND WITH ALL FAULTS AND BROADCOM MAKES NO PROMISES, REPRESENTATIONS OR 
 * WARRANTIES, EITHER EXPRESS, IMPLIED, STATUTORY, OR OTHERWISE, WITH RESPECT TO 
 * THE SOFTWARE.  BROADCOM SPECIFICALLY DISCLAIMS ANY AND ALL IMPLIED WARRANTIES 
 * OF TITLE, MERCHANTABILITY, NONINFRINGEMENT, FITNESS FOR A PARTICULAR PURPOSE, 
 * LACK OF VIRUSES, ACCURACY OR COMPLETENESS, QUIET ENJOYMENT, QUIET POSSESSION 
 * OR CORRESPONDENCE TO DESCRIPTION. YOU ASSUME THE ENTIRE RISK ARISING OUT OF 
 * USE OR PERFORMANCE OF THE SOFTWARE.
 * 
 * 3.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, IN NO EVENT SHALL BROADCOM OR ITS 
 * LICENSORS BE LIABLE FOR (i) CONSEQUENTIAL, INCIDENTAL, SPECIAL, INDIRECT, OR 
 * EXEMPLARY DAMAGES WHATSOEVER ARISING OUT OF OR IN ANY WAY RELATING TO YOUR 
 * USE OF OR INABILITY TO USE THE SOFTWARE EVEN IF BROADCOM HAS BEEN ADVISED OF 
 * THE POSSIBILITY OF SUCH DAMAGES; OR (ii) ANY AMOUNT IN EXCESS OF THE AMOUNT 
 * ACTUALLY PAID FOR THE SOFTWARE ITSELF OR U.S. $1, WHICHEVER IS GREATER. THESE 
 * LIMITATIONS SHALL APPLY NOTWITHSTANDING ANY FAILURE OF ESSENTIAL PURPOSE OF 
 * ANY LIMITED REMEDY.
 *
 * $brcm_Workfile: shim_nexus.h $
 * $brcm_Revision: DirectFB_1_4_Port/2 $
 * $brcm_Date: 7/26/10 4:57p $
 * 
 * Module Description:
 * 
 * Revision History:
 * 
 * $brcm_Log: /AppLibs/opensource/directfb/src/broadcom_files/public/DirectFB/1.4/shim_nexus.h $
 * 
 * DirectFB_1_4_Port/2   7/26/10 4:57p jackf
 * SW35230-771: Populated the redirection defines, conditional on
 *  "USE_SHIM" being defined.
 * 
 * DirectFB_1_4_Port/1   7/26/10 4:50p jackf
 * SW35230-771: Create shim_nexus.h.
 * 
 *****************************************************************************/
// Include this in all source files in DFB that make Nexus calls.

// This file redirect Nexus calls to functions that use some sort of cross 
// process API to allow use on versions of Nexus that cannot be compiled in 
// kernel mode.

#ifdef USE_SHIM

// Function replacement defines

#define NEXUS_Display_GetSettings                           shim_nexus_Display_GetSettings
#define NEXUS_Display_SetSettings                           shim_nexus_Display_SetSettings
#define NEXUS_Display_GetGraphicsSettings                   shim_nexus_Display_GetGraphicsSettings
#define NEXUS_Display_SetGraphicsSettings                   shim_nexus_Display_SetGraphicsSettings
#define NEXUS_Display_SetGraphicsFramebuffer                shim_nexus_Display_SetGraphicsFramebuffer

#define NEXUS_Graphics2D_GetSettings                        shim_nexus_Graphics2D_GetSettings
#define NEXUS_Graphics2D_SetSettings                        shim_nexus_Graphics2D_SetSettings
#define NEXUS_Graphics2D_Checkpoint                         shim_nexus_Graphics2D_Checkpoint
#define NEXUS_Graphics2D_GetDefaultBlitSettings             shim_nexus_Graphics2D_GetDefaultBlitSettings
#define NEXUS_Graphics2D_GetDefaultFillSettings             shim_nexus_Graphics2D_GetDefaultFillSettings
#define NEXUS_Graphics2D_GetDefaultPorterDuffFillSettings   shim_nexus_Graphics2D_GetDefaultPorterDuffFillSettings
#define NEXUS_Graphics2D_Blit                               shim_nexus_Graphics2D_Blit
#define NEXUS_Graphics2D_FastBlit                           shim_nexus_Graphics2D_FastBlit
#define NEXUS_Graphics2D_Fill                               shim_nexus_Graphics2D_Fill
#define NEXUS_Graphics2D_PorterDuffFill                     shim_nexus_Graphics2D_PorterDuffFill

#define NEXUS_IrInput_Open                                  shim_nexus_IrInput_Open
#define NEXUS_IrInput_Close                                 shim_nexus_IrInput_Close
#define NEXUS_IrInput_GetDefaultSettings                    shim_nexus_IrInput_GetDefaultSettings
#define NEXUS_IrInput_GetEvents                             shim_nexus_IrInput_GetEvents

#define NEXUS_Keypad_Open                                   shim_nexus_Keypad_Open
#define NEXUS_Keypad_Close                                  shim_nexus_Keypad_Close
#define NEXUS_Keypad_GetDefaultSettings                     shim_nexus_Keypad_GetDefaultSettings
#define NEXUS_Keypad_GetEvents                              shim_nexus_Keypad_GetEvents

#define NEXUS_PictureDecoder_Open                           shim_nexus_PictureDecoder_Open
#define NEXUS_PictureDecoder_Close                          shim_nexus_PictureDecoder_Close
#define NEXUS_PictureDecoder_Start                          shim_nexus_PictureDecoder_Start
#define NEXUS_PictureDecoder_Stop                           shim_nexus_PictureDecoder_Stop
#define NEXUS_PictureDecoder_GetBuffer                      shim_nexus_PictureDecoder_GetBuffer
#define NEXUS_PictureDecoder_GetDefaultStartSettings        shim_nexus_PictureDecoder_GetDefaultStartSettings
#define NEXUS_PictureDecoder_GetPalette                     shim_nexus_PictureDecoder_GetPalette
#define NEXUS_PictureDecoder_GetStatus                      shim_nexus_PictureDecoder_GetStatus
#define NEXUS_PictureDecoder_DecodeSegment                  shim_nexus_PictureDecoder_DecodeSegment
#define NEXUS_PictureDecoder_ReadComplete                   shim_nexus_PictureDecoder_ReadComplete

#define NEXUS_Surface_GetDefaultCreateSettings              shim_nexus_Surface_GetDefaultCreateSettings
#define NEXUS_Surface_GetCreateSettings                     shim_nexus_Surface_GetCreateSettings
#define NEXUS_Surface_Create                                shim_nexus_Surface_Create
#define NEXUS_Surface_Destroy                               shim_nexus_Surface_Destroy
#define NEXUS_Surface_GetMemory                             shim_nexus_Surface_GetMemory
#define NEXUS_Surface_Flush                                 shim_nexus_Surface_Flush

#define NEXUS_Memory_Allocate                               shim_nexus_Memory_Allocate
#define NEXUS_Memory_Free                                   shim_nexus_Memory_Free
#define NEXUS_Memory_GetDefaultAllocationSettings           shim_nexus_Memory_GetDefaultAllocationSettings

#define NEXUS_Platform_GetConfiguration                     shim_nexus_Platform_GetConfiguration
#define NEXUS_Platform_Join                                 shim_nexus_Platform_Join

#define NEXUS_Heap_GetStatus                                shim_nexus_Heap_GetStatus
#define NEXUS_StopCallbacks                                 shim_nexus_StopCallbacks
#define NEXUS_VideoFormat_GetInfo                           shim_nexus_VideoFormat_GetInfo

#endif

